package nu.fw.jeti.applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.MessageFormat;
import java.util.LinkedList;
import java.util.Map;

import javax.swing.JApplet;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.SwingUtilities;

import nu.fw.jeti.backend.LoginInfo;
import nu.fw.jeti.backend.Start;
import nu.fw.jeti.events.StatusChangeListener;
import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.jabber.JID;
import nu.fw.jeti.jabber.UnknownJIDStatus;
import nu.fw.jeti.jabber.elements.IQPrivate;
import nu.fw.jeti.jabber.elements.InfoQuery;
import nu.fw.jeti.ui.AddContact;
import nu.fw.jeti.ui.LoginStatusWindow;
import nu.fw.jeti.util.I18N;
import nu.fw.jeti.util.Popups;
import nu.fw.jeti.util.Preferences;

/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2003 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or jabber/mail me at jeti@jabber.org
 *
 *	Created on 14-nov-2003
 */

/**
 * @author E.S. de Boer
 *
 */
public class Jeti extends JApplet
{
	private Start start;
	public static JLabel from;
	private static Jeti applet;
	private URL exitURL;
	private static String groupchatRoom;
	private static String groupchatServer;
	static LoginInfo loginInfo;
	private static boolean randomName=false;
	private Backend backend;
	private boolean started=false;
	private SecureMethodRunner secureMethodInvoker;
	
		
	public void init()
	{
		
		applet = this;
		splash();
		Thread t = new Thread()
		{
			public void run()
			{
				String server = getParameter("SERVER");
				String portText = getParameter("PORT");
				boolean ssl = Boolean.valueOf(getParameter("SSL")).booleanValue();
				String user = getParameter("USER");
				String password = getParameter("PASSWORD");
				String resource = getParameter("RESOURCE");
				String host = getParameter("HOST");
				groupchatRoom = getParameter("GROUPCHATROOM");
				groupchatServer = getParameter("GROUPCHATSERVER");
				
				
								
				//String language = getParameter("LANGUAGE");
				//String country = getParameter("COUNTRY");
				try
				{
                     exitURL = new URL(getDocumentBase(),getParameter("EXITPAGE"));
				} catch (MalformedURLException e)
				{
					try
					{
						exitURL = new URL("http://jeti.jabberstudio.org");
					} catch (MalformedURLException e1)
					{
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
				if(server!=null || resource!=null || portText!=null)
				{
					if(resource == null) resource = "JetiApplet";
					else if(resource.equals("random"))
					{
						resource = "JetiRandom" +  System.currentTimeMillis();
						randomName = true;
					}
					int port;
					try
					{
						port = Integer.parseInt(portText);
					}
					catch (NumberFormatException ex)
					{
						if(ssl) port = 5223;
						else port = 5222;
					}
					boolean statuswin = Boolean.valueOf(getParameter("HIDELOGINSTATUS")).booleanValue();
					loginInfo = new LoginInfo(server,host,user,password,resource,port,ssl,0,statuswin);
				}
				Start.programURL = getCodeBase();
				Start.applet = true;
				final JPanel panel = new JPanel(new BorderLayout());
				start = new Start(getCodeBase().toString(),panel);
				String ownName = getParameter("OWNNAME");
				if(ownName!=null) Preferences.addDefaultPreferences("jeti.ownName", ownName);
				
				if(Boolean.valueOf(getParameter("ANONYMOUS")).booleanValue())
				{
					Preferences.addDefaultPreferences("xmpp.anonymousLogin", "true");
					randomName = true;
				}
				
				String preferences = getParam("DEFAULTPREFERENCES");
				if(preferences!=null)
				{
					String prefs[] =preferences.split(";");
					for (int i = 0; i < prefs.length; i++)
					{
						int index = prefs[i].indexOf("#");
						System.out.println(prefs[i].substring(0,index));
						System.out.println(prefs[i].substring(index+1));
						Preferences.addDefaultPreferences(prefs[i].substring(0,index).trim()
									,prefs[i].substring(index+1).trim());
					}
				}
				I18N.init();//reinit languages incase they changed
				backend = start.getBackend();
				backend.getMain().translate();
				
				if(!Preferences.getBoolean("jeti", "hideLoginWindow", false))
				{
					if(loginInfo == null) new LoginWindow(backend).setVisible(true);
					else if(loginInfo.getPassword()==null)
					{
						new LoginWindow(backend).setVisible(true);
					}
				}
				if(loginInfo!=null && loginInfo.getPassword()!=null) new LoginStatusWindow(loginInfo,backend,1);
								
				secureMethodInvoker = new SecureMethodRunner(backend);
				secureMethodInvoker.start();
				backend.addExtensionHandler("jeti:prefs",new PreferencesHandler());
				try {
				backend.addListener(StatusChangeListener.class,new StatusChangeListener()
				{
					public void connectionChanged(boolean online)
					{//get preferences
						System.out.println("get pref");
						if(online)
						{
							backend.send(new InfoQuery("get",new IQPrivate(new JetiPrivatePreferencesExtension())));
							String chatTO = getParameter("CHATTO");
							if(chatTO!=null && chatTO.length()>0)
				    		{
				    			if(Boolean.valueOf(getParameter("SHOWCHATTOASMAIN")).booleanValue())
				    			{
				    				setContentPane(backend.getMain().createChatPanel(new UnknownJIDStatus(JID.jidFromString(chatTO))));
				    				validate();
				    			}
				    			else backend.getMain().startChat(JID.jidFromString(chatTO));
							}
							
							if(groupchatServer != null && groupchatRoom !=null)
				    		{
								System.out.println("starting groupchat things");
				    			String nick = getParameter("GROUPCHATNICK");
				    			if(nick ==null && randomName)
				    			{
				    				nick = JOptionPane.showInputDialog(backend.getMainWindow(),"Enter your nickname");
				    			}
				    			if(nick==null) nick = backend.getMyJID().getUser();
				    			JID jid = new JID(Jeti.groupchatRoom,Jeti.groupchatServer,nick);
				    			if(Boolean.valueOf(getParameter("SHOWGROUPCHATASMAIN")).booleanValue())
				    			{
				    				String groupchatRoom2 =getParameter("GROUPCHATROOM2");
				    				if(groupchatRoom2!=null)
				    				{
				    					System.out.println("two jids");
				    					JID jid2= new JID(groupchatRoom2,Jeti.groupchatServer,nick);
				    					JPanel gw = LoadGroupChat.createGroupChatWindow(jid);
				    					JPanel gw2 = LoadGroupChat.createGroupChatWindow(jid2);
				    					JSplitPane spl = new JSplitPane(JSplitPane.VERTICAL_SPLIT,gw,gw2);
				    					setContentPane(spl);
				    					spl.setDividerLocation(0.5);
				    					LoadGroupChat.startGroupchat(jid2,backend);
				    				}
				    				else
				    				{
					    				JPanel gw = LoadGroupChat.createGroupChatWindow(jid);
						    			setContentPane(gw);
						    			if(!Preferences.getBoolean("groupchat", "hideGroupchatMenu", false))
						    			{
							    			JMenu[] menu = LoadGroupChat.getMenu(gw);
							    			setJMenuBar(new JMenuBar());
							    			for(int i=0;i<menu.length;i++)
							    			{
							    				getJMenuBar().add(menu[i]);
							    			}
						    			}
				    				}
				    				validate();
				    			}
								LoadGroupChat.startGroupchat(jid,backend);
				    			String invites = getParameter("GROUPCHATINVITE");
				    			if(invites!=null)
				    			{
				    				String[] invite = invites.split(",");
				    				JID room = new JID(Jeti.groupchatRoom,Jeti.groupchatServer);
				    				for(int i=0;i<invite.length;i++)
				    				{
				    					LoadGroupChat.invite(backend,new JID(invite[i]),room);
				    				}
				    			}
				    		}
				    		else if(groupchatServer != null)
				    		{
				    			LoadGroupChat.signin(backend,Jeti.groupchatServer);
				    		}
						}
					}
					
					public void ownPresenceChanged(int show, String status)	{}
					public void exit(){}
				});
				} catch(NoClassDefFoundError e) {e.printStackTrace();}
				new Popups(Jeti.this);
				SwingUtilities.invokeLater(new Runnable()
				{
					public void run()
					{
						setContentPane(panel);
						validate();
						//start.initPopups();
					}
				});
				started=true;
			}
		};
		t.start();
	}
			
	private void splash()
	{ 
		JLabel label = new JLabel("Jeti is Loading"+"...");
		label.setFont(new java.awt.Font("Serif", 1, 28)); 
		label.setBackground(new Color(150,150,255));
		getContentPane().setBackground(new Color(150,150,255));
		getContentPane().add(label,BorderLayout.CENTER);
		JPanel panel = new JPanel();
		panel.setBackground(new Color(255,255,150));
		from = new JLabel("(c) 2001-2008 E.S. de Boer");
		from.setBackground(new Color(255,255,150));
		panel.add(from);
		JLabel version = new JLabel("Version: " + Start.VERSION);
		version.setBackground(new Color(255,255,150));
		panel.add(version);
		getContentPane().add(panel,BorderLayout.SOUTH); 
	}
	
	public static void showURL(String url)
	{
		try
		{
			applet.getAppletContext().showDocument(new URL(url),"_blank");
		} catch (MalformedURLException e)
		{//wrong url
		}
	}
		
	public void destroy()
	{
		try {
			if(secureMethodInvoker!=null)secureMethodInvoker.stopRunning();
			start.close();
		}catch (Exception e) 
		{//catch all exceptions else jvm hangs
			e.printStackTrace();
		} 
	}
		
	public static void exit()
	{
		applet.getAppletContext().showDocument(applet.exitURL);
	}
	
	public boolean isReady()
	{
		System.out.println("ready " + started);
		return started;
	}
	
	public boolean isLoggedIn()
	{
		if(!started)return false;
		return backend.isLoggedIn();
	}
	
	public void openChat(String jid)
	{
		try
		{
			JID j = JID.checkedJIDFromString(jid);
			secureMethodInvoker.addData(new Object[]{"openChat",j});
		} catch (InstantiationException e)
		{
			e.printStackTrace();
		}
		
		//backend.getMain().startChat(j);
	}
	
	public void addContact(String jid)
	{
		try
		{
			JID j = JID.checkedJIDFromString(jid);
			secureMethodInvoker.addData(new Object[]{"addContact",j});
		} catch (InstantiationException e)
		{
			e.printStackTrace();
		}
		//new AddContact(j, null, backend).show();
		
	}
	
	public void login(String username,String server,String password)
	{
		if(backend.isLoggedIn())
		{
			JID j =backend.getMyJID();
			if(j.getDomain().equals(server)&& j.getUser().equals(username))
			{
				return;
			}
		}
		secureMethodInvoker.addData(new Object[]{"login",username,server,password});
		
//		if(username==null || password==null)
//		{
//			new nu.fw.jeti.applet.LoginWindow(backend).show();
//		}
//		else new LoginStatusWindow(new LoginInfo(server,loginInfo.getHost(),username,password,
//				loginInfo.getResource(),loginInfo.getPort(),loginInfo.isSSl()),backend,1);
	}
	
//	public void login(String username,String server,String password,String resource, String port,String ssl)
//	{
//		if(username==null || password==null)
//		{
//			new nu.fw.jeti.applet.LoginWindow(backend).show();
//		}
//		else
//		{
//			boolean ssl = Boolean.valueOf(ssl).booleanValue();
//			new LoginStatusWindow(new LoginInfo(server,loginInfo.getHost(),username,password,
//				resource,port,ssl),backend,1);
//		}
//	}
	
	public static String getParam(String name)
	{
		return applet.getParameter(name);
	}
	
	public static Class getPlugin(String name)
	{//keyboardflash does not work //filetranser requires home.read permision
		try
        {
            return Class.forName("nu.fw.jeti.plugins."+name+".Plugin");
		}
        catch (ClassNotFoundException e)
		{
			System.err.println(MessageFormat.format(I18N.gettext("main.error.{0}_plugin_not_found"), new Object[]{name}));
			return null;
		}
	}
	
	public static void getPrefPanel(String name,Map loadedPreferencePanels)
	{
		Class prefPanel =null;
		try
		{
			prefPanel = Class.forName("nu.fw.jeti.plugins."+name+".PrefPanel");
			//if(name.equals("emoticons")) prefPanel = nu.fw.jeti.plugins.emoticons.PrefPanel.class;
			//else if(name.equals("xhtml")) prefPanel = nu.fw.jeti.plugins.xhtml.PrefPanel.class;
			//else return;
		}
		catch (ClassNotFoundException e)
		{
			return;
		}
		loadedPreferencePanels.put(name,prefPanel);
	}
	
	static class SecureMethodRunner extends Thread
	{
		
		private Backend backend;
		private LinkedList queue = new LinkedList();
		private volatile boolean isRunning=true;

	    SecureMethodRunner(Backend backend)
		{
	    	this.backend = backend;
		}
		
	    public void addData(Object method)
	    {
	    	synchronized(queue)
			{
				queue.addLast(method);
				queue.notifyAll();
			}
	    }
	    
	    public void stopRunning()
	    {
	    	isRunning = false;
			synchronized(queue){queue.notifyAll();}
	    }
	    

		public void run()
		{
			Object[] method;
			while (isRunning)
			{
				synchronized (queue)
				{
					if (queue.isEmpty())
					{
						try
						{
							queue.wait();
						} catch (InterruptedException e)
						{//bug when thrown? called when interrupted
							e.printStackTrace();
							return;
						}
						continue;
					}
					method = (Object[]) queue.removeFirst();
					
				}
				String m = (String)method[0];
				if(m.equals("openChat")) backend.getMain().startChat((JID)method[1]);
				else if (m.equals("addContact")) new AddContact((JID)method[1], null, backend).setVisible(true);
				else if (m.equals("login")) login((String)method[1],(String)method[2],(String)method[3]);
			}
		}
		
		public void login(String username,String server,String password)
		{
			if(loginInfo==null)loginInfo = new LoginInfo(null,null,null,null,"JetiApplet",5222,false,0);
			if(username==null || password==null)
			{
				new nu.fw.jeti.applet.LoginWindow(backend).setVisible(true);
			}
			else new LoginStatusWindow(new LoginInfo(server,loginInfo.getHost(),username,password,
					loginInfo.getResource(),loginInfo.getPort(),loginInfo.isSSl(),0),backend,1);
		}
	}
	}

/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
