/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2001 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/IM me at jeti@jabber.org
 *  
 *  Created in 2002
 */

package nu.fw.jeti.backend.roster;

import javax.swing.ImageIcon;

import nu.fw.jeti.jabber.JID;
import nu.fw.jeti.jabber.JIDStatus;
import nu.fw.jeti.jabber.elements.Presence;
import nu.fw.jeti.plugins.Avatars;
import nu.fw.jeti.plugins.PluginsInfo;

/**
 * @author E.S. de Boer
 */

public abstract class SecondaryJIDStatus extends JIDStatus
{
	private Avatars avatars;
	private String msnNick;
		
	public void updatePresence(Presence presence)
	{
		online = presence.getType().equals("available");
		show = presence.getShow();
		status = presence.getStatus();
		completeJID = presence.getFrom();
		Avatars avatars = getAvatarInterface();
		if(avatars!=null)
		{
			if(!presence.hasExtensions())return;
			avatars.update(presence,this);
		}
	}
	
	private Avatars getAvatarInterface()
	{
		if(avatars!=null)return avatars;
		if(PluginsInfo.isPluginLoaded("ichatavatars"))
		{
			avatars =  (Avatars)PluginsInfo.getPluginInstance("ichatavatars");
			return avatars;
		}
		return null;
	}
	
	public void setAvatar(ImageIcon icon)
	{
		avatar = icon;
	}
	
	public String getMSNNick()
	{
		return msnNick;
	}
	
	public void setMSNNick(String nick)
	{
		msnNick = nick;
	}
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
