package nu.fw.jeti.plugins.buddyspacemaps.core;

/*
 * FileCopier.java
 *
 * Project: BuddySpace
 * (C) Copyright Knowledge Media Institute 2002
 *
 *
 * Created on 17 December 2002, 16:36
 *
 * E.S. de Boer
 * converted to jeti plugin
 */

import java.io.*;

/**
 * <code>FileCopier</code> provides copying of files.
 *
 * @author  Jiri Komzak, Knowledge Media Institute, Open University, United Kingdom
 */
public class FileCopier {
    
    /** Size of used buffer */
    public static int BUFFER_SIZE = 1024;
    
    /** Copies file and returns if successful. */
    public static boolean copyFile(File inFile, File outFile) {
        
        try {
            if (inFile.equals(outFile))
                return true;
            if (outFile != null && outFile.getParentFile() != null)
                outFile.getParentFile().mkdirs();
            
            FileInputStream input  = new FileInputStream(inFile);
            FileOutputStream output = new FileOutputStream(outFile);
            byte[] buffer = new byte[BUFFER_SIZE];
            int byteNum;
            while(-1 != (byteNum = input.read(buffer))) {
                output.write(buffer, 0, byteNum);
            }
            input.close();
            output.close();
            return true;
            
        } catch (FileNotFoundException e) {
            return false;
        } catch (IOException e) {
            return false;
        }
    }
    
}