package nu.fw.jeti.plugins.buddyspacemaps.editor;

/*
 * BSChooseJIDDialog.java
 *
 * Project: BuddySpace
 * (C) Copyright Knowledge Media Institute 2002
 *
 *
 * Created on 23 September 2002, 14:34
 * 
 * E.S. de Boer
 * contverted to jeti plugin
 */

import java.awt.Frame;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Iterator;
import java.util.TreeMap;

import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JOptionPane;

import nu.fw.jeti.backend.roster.Roster;
import nu.fw.jeti.jabber.JID;
import nu.fw.jeti.jabber.JIDStatus;

/**
 * Dialog for specifying JID.
 *
 * @author  Jiri Komzak, Knowledge Media Institute, Open University, United Kingdom
 */

public class BSChooseJIDDialog extends JDialog {
    private JOptionPane optionPane;
    public JID jid = null;
    
    /** Constructor */
    public BSChooseJIDDialog(Frame _parent, String title) {
        super(_parent, title, true);
        
        final Frame parent = _parent;
        
        // fills jid hashtable and sorted jid combo box
        final JComboBox jidComboBox = new JComboBox();
        jidComboBox.setEditable(true);
        final TreeMap jids = new TreeMap();
        Iterator rosterItems = Roster.getJIDStatussen();
        while (rosterItems.hasNext()) {
            JIDStatus ri = (JIDStatus) rosterItems.next();
            JID jid = ri.getJID();
            String label = ri.getNick() + " (" + jid.toString() + ")";
            jids.put(label, jid);
            //jidComboBox.addItem(label);
        }
        TreeMap tmpMap = (TreeMap) jids.clone();
        while (!tmpMap.isEmpty()) {
            Object o = tmpMap.firstKey();
            jidComboBox.addItem(o);
            tmpMap.remove(o);
        }

        //final JTextField jenTak = new JTextField("");
        Object[] fields = {"JID: ", jidComboBox};
                           //, "Jen tak: ", jenTak};
        
        final String okButton = "OK";
        final String cancelButton = "Cancel";
        Object[] options = {okButton, cancelButton};

        optionPane = new JOptionPane(fields, 
                                     JOptionPane.PLAIN_MESSAGE,
                                     JOptionPane.OK_CANCEL_OPTION,
                                     null,
                                     options,
                                     options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);

        pack();
        setLocationRelativeTo(parent);
        
        // handles actions
        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();
			
                if (isVisible() 
                    && (e.getSource() == optionPane)
                    && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                      prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        // ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(okButton)) {
                        String jidTxt = (String) jidComboBox.getSelectedItem();
                        jid = (JID) ((jidTxt != null)? jids.get(jidTxt) : null);
                        if (jid == null)
                        {
                        	try {
                            jid = JID.checkedJIDFromString(jidTxt);
                        	}catch(InstantiationException e2) {}
                        }
                        if (jid == null) {
                            JOptionPane.showMessageDialog(parent, "Invalid JID", 
                                                          "Error", 
                                                          JOptionPane.ERROR_MESSAGE);
                            return;
                        }
                        setVisible(false);
                    }
                    else if (value.equals(cancelButton)) {
                        jid = null;
                        setVisible(false);
                    }
                }
            }
        });
    }
}