package nu.fw.jeti.plugins.buddyspacemaps.editor;

/*
 * BSJIDLabel.java
 *
 * Project: BuddySpace
 * (C) Copyright Knowledge Media Institute 2002
 *
 *
 * Created on 19 August 2002, 9:41
 * 
 * E.S. de Boer
 * converted to jeti plugin
 */

import javax.swing.Icon;
import javax.swing.JLabel;

import nu.fw.jeti.jabber.JID;

/**
 * <code>BSJIDLabel</code> is a icon label for specified JID. 
 * It is meant to display presence specific icon and tooltip including
 * JID's nick name and JID string representation.
 *
 * @author  Jiri Komzak, Knowledge Media Institute, Open University, United Kingdom
 */
public class BSJIDLabel extends JLabel {
    
    private JID jid = null;
    private String nick;
    //private String toolTipText = null;
    
    /** Constructor */
    public BSJIDLabel(JID jid, String nick, Icon img) {
        super(img);
        this.jid = jid;
        this.nick = nick;
        setToolTipText(nick + " (" + jid.toString() + ")");
    }
    
    /** Sets current icon */
    public void setImg(Icon img) {
        setIcon(img);
    }
    
    /** Sets nick */
    public void setNick(String nick) {
        this.nick = nick;
        setToolTipText(nick + " (" + jid.toString() + ")");
    }
    
    /** Returns label's jid */
    public JID getJID() {
        return jid;
    }
    
}