package nu.fw.jeti.plugins.buddyspacemaps.editor;

/*
 * BSMapEditClusterLabel.java
 *
 * Project: BuddySpace
 * (C) Copyright Knowledge Media Institute 2002
 *
 *
 * Created on 30 Sempember 2002, 16:06
 * 
 * E.S. de Boer
 * converted to jeti plugin
 */

import java.awt.Color;

import javax.swing.Icon;
import javax.swing.border.LineBorder;

import nu.fw.jeti.plugins.buddyspacemaps.gui.BSClusterLabel;
import nu.fw.jeti.plugins.buddyspacemaps.xml.ClusterTag;
import nu.fw.jeti.plugins.buddyspacemaps.xml.LayerTag;



/**
 * <code>BSMapEditClusterLabel</code> is a icon label for specified cluster. 
 * It is meant to display presence specific icon and tooltip.
 *
 * @author  Jiri Komzak, Knowledge Media Institute, Open University, United Kingdom
 */
public class BSMapEditClusterLabel extends BSClusterLabel {
    
    private LayerTag layerTag;
    private boolean editable = false;
    
    /** Constructor */
    public BSMapEditClusterLabel(ClusterTag tag, Icon img, 
                             LayerTag layerTag, boolean editable) {
        super(tag, img);
        this.layerTag = layerTag;
        this.editable = editable;
    }
    
    /** Returns label's tag */
    public ClusterTag getTag() {
        return cluster;
    }
    
    /** Returns label's layer tag */
    public LayerTag getLayerTag() {
        return layerTag;
    }
    
    /** Displays the label as (un)selected */
    public void setAsSelected(boolean selected) {
        setBorder(selected? new LineBorder(Color.yellow, 2) : null);
    }
    
    /** Displays the label as (un)edited */
    public void setAsEdited(boolean edited) {
        setBorder(edited? new LineBorder(Color.green, 2) : null);
    }
    
    /** Returns if the label is editable */
    public boolean isEditable() {
        return editable;
    }
    
}