package nu.fw.jeti.plugins.buddyspacemaps.editor;

/*
 * BSMapFilter.java
 *
 * Project: BuddySpace
 * (C) Copyright Knowledge Media Institute 2003
 *
 *
 * Created on 7 January 2003, 15:09
 * E.S. de Boer
 * converted to jeti plugin
 */

import javax.swing.filechooser.*;
import java.io.File;

/**
 * <code>BSMapFilter</code> provides filtering of map files for JFileChooser.
 *
 * @author  Jiri Komzak, Knowledge Media Institute, Open University, United Kingdom
 *
 * Inspired by java.sun.com
 */
public class BSMapFilter extends FileFilter {
    
    // Accept all directories and all ygf files.
    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }

        String extension = getExtension(f);
        if (extension != null) {
            if (extension.equals("ygf")) {
                return true;
            } else {
            return false;
        }
    }

    return false;
    }

    // The description of this filter
    public String getDescription() {
        return "BS map files";
    }
    
    /** Get the extension of a file. */  
    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }
}