package nu.fw.jeti.plugins.buddyspacemaps.editor;

/*
 * ImageFilter.java
 *
 * Project: BuddySpace
 * (C) Copyright Knowledge Media Institute 2003
 *
 *
 * Created on 7 January 2003, 14:55
 *E.S. de Boer
 * converted to jeti plugin 
 */

import javax.swing.filechooser.*;
import java.io.File;
//import java.util.*;

/**
 * <code>ImageFilter</code> provides filtering of image files for JFileChooser.
 *
 * @author  Jiri Komzak, Knowledge Media Institute, Open University, United Kingdom
 *
 * Inspired by java.sun.com
 */
public class ImageFilter extends FileFilter {
    
    // Accept all directories and all gif, jpg, or png files.
    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }

        String extension = getExtension(f);
        if (extension != null) {
            if (extension.equals("gif") ||
                extension.equals("jpg") ||
                extension.equals("jpeg") ||
                extension.equals("png")) {
                return true;
            } else {
            return false;
        }
    }

    return false;
    }

    // The description of this filter
    public String getDescription() {
        return "Image files";
    }
    
    /** Get the extension of a file. */  
    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }
}