package nu.fw.jeti.plugins.buddyspacemaps.gui;

/*
 * BSJIDActionMenuItem.java
 *
 * Project: BuddySpace
 * (C) Copyright Knowledge Media Institute 2002
 *
 *
 * Created on 1 October 2002, 10:01
 * 
 * E.S. de Boer
 * converted to jeti plugin
 */

import javax.swing.JMenuItem;

import nu.fw.jeti.jabber.JID;

/**
 * <code>BSJIDActionMenuItem</code> stores <code>JID</code> and desired
 * action namespace information.
 *
 * @author  Jiri Komzak, Knowledge Media Institute, Open University, United Kingdom
 */
public class BSJIDActionMenuItem extends JMenuItem {
    
    private JID jid = null;
    private String namespace = null;
    
    /** Constructor */
    public BSJIDActionMenuItem(String text) {
        super(text);
    }
    
    /** Constructor */
    public BSJIDActionMenuItem(String text, JID jid) {
        this(text);
        this.jid = jid;
    }
    
    /** Constructor */
    public BSJIDActionMenuItem(String text, JID jid, String namespace) {
        this(text, jid);
        this.namespace = namespace;
    }
    
    /** Sets JID */
    public void setJID(JID jid) {
        this.jid = jid;
    }
    
    /** Returns JID */
    public JID getJID() {
        return jid;
    }
    
    /** Sets namespace */
    public void setNamespace(String namespace) {
        this.namespace = namespace;
    }
    
    /** Returns namespace */
    public String getNamespace() {
        return namespace;
    }
}
