package nu.fw.jeti.plugins.buddyspacemaps.gui;

/*
 * BSJIDLabelList.java
 *
 * Project: BuddySpace
 * (C) Copyright Knowledge Media Institute 2002
 *
 *
 * Created on 19 August 2002, 9:49
 * 
 * E.S. de Boer
 * converted to jeti plugin
 */

import java.util.Enumeration;
import java.util.Vector;

import javax.swing.Icon;

import nu.fw.jeti.jabber.JID;
import nu.fw.jeti.plugins.buddyspacemaps.editor.BSJIDLabel;

/**
 * <code>BSJIDLabelList</code> is list of <code>BSJIDLabel</code>s for one
 * JID. It is used for fast update of all labels for given jid.
 *
 * @author  Jiri Komzak, Knowledge Media Institute, Open University, United Kingdom
 */
public class BSJIDLabelList {
    
    private JID jid = null;
    private Vector jidLabels = null;
    
    /** Constructor */
    public BSJIDLabelList(JID jid) {
        this.jid = jid;
        jidLabels = new Vector();
    }
    
    /** Adds <code>BSJIDLabel</code> into the list */
    public void addLabel(BSJIDLabel lbl) {
        jidLabels.add(lbl);
    }
    
    /** Deletes <code>BSJIDLabel</code> from the list */
    public void delLabel(BSJIDLabel lbl) {
        jidLabels.remove(lbl);
    }
    
    /** Sets icon for all labels in the list */
    public void setImg(Icon img) {
        Enumeration elements = jidLabels.elements();
        while (elements.hasMoreElements()) {
            BSJIDLabel elem = (BSJIDLabel) elements.nextElement();
            elem.setImg(img);
        }
    }
    
    /** Sets nick for all labels in the list */
    public void setNick(String nick) {
        Enumeration elements = jidLabels.elements();
        while (elements.hasMoreElements()) {
            BSJIDLabel elem = (BSJIDLabel) elements.nextElement();
            elem.setNick(nick);
        }
    }
    
    /** Returns JID of list */
    public JID getJID() {
        return jid;
    }
    
}