package nu.fw.jeti.plugins.buddyspacemaps.gui;

/*
 * BSMapMenuItem.java
 *
 * Project: BuddySpace
 * (C) Copyright Knowledge Media Institute 2002
 *
 *
 * Created on 27 August 2002, 15:10
 * E.S. de Boer
 * converted to jeti plugin
 */

import javax.swing.JMenuItem;

/**
 * <code>BSMapMenuItem</code> is a menu item including map ID information
 * to allow calling of action for specific map.
 *
 * @author  Jiri Komzak, Knowledge Media Institute, Open University, United Kingdom
 */
public class BSMapMenuItem extends JMenuItem {
    String mapName;
    String originID;
    
    /** Constructor */
    public BSMapMenuItem(String label, String mapName, String originID) {
        super(label);
        this.mapName = mapName;
        this.originID = originID;
    }
    
    /** Returns map name */
    public String getMapName() {
        return mapName;
    }
    
    /** Returns map origin */
    public String getOriginID() {
        return originID;
    }
}