package nu.fw.jeti.plugins.buddyspacemaps.gui;

/*
 * BSMapSendDialog.java
 *
 *
 * Project: BuddySpace
 * (C) Copyright Knowledge Media Institute 2002
 *
 *
 * Created on 17 September 2002, 15:18
 * 
 * E.S. de Boer
 * converted to jeti plugin
 */

import java.awt.Frame;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.TreeMap;

import javax.swing.*;

import nu.fw.jeti.jabber.JID;

/**
 * <code>BSMapSendDialog</code> allows input of parameters for 
 * send of map.
 *
 * @author  Jiri Komzak, Knowledge Media Institute, Open University, United Kingdom
 */

public class BSMapSendDialog extends JDialog {
    private JOptionPane optionPane;
    public JID jid = null;
    public String body;
    public String subject;
    
    /** Constructor */
    public BSMapSendDialog(Frame _parent) {
                         
        super(_parent, "Send invitation", true);
        
        final Frame parent = _parent;
        
        final JComboBox recipientComboBox = new JComboBox();
        final JTextField subjectTextField = new JTextField();
        final JTextArea bodyTextArea = new JTextArea();
        
        bodyTextArea.setRows(3);
        bodyTextArea.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(100, 100, 100)));
        bodyTextArea.setLineWrap(true);
        bodyTextArea.setWrapStyleWord(true);
        
        final TreeMap recipients = new TreeMap();
        /*
        while (rosterItems.hasMoreElements()) {
            RosterItem ri = (RosterItem) rosterItems.nextElement();
            JID jid = ri.getJID();
            String label = ri.getName() + " (" + jid.toString() + ")";
            recipients.put(label, jid);
            //recipientComboBox.addItem(label);
        }
        */
        TreeMap tmpMap = (TreeMap) recipients.clone();
        while (!tmpMap.isEmpty()) {
            Object o = tmpMap.firstKey();
            recipientComboBox.addItem(o);
            tmpMap.remove(o);
        }
        recipientComboBox.setEditable(true);
        
        Object[] fields = {"Recipient: ", recipientComboBox,
                           "Subject: ", subjectTextField,
                           "Body: ", bodyTextArea};
        
        final String okButton = "OK";
        final String cancelButton = "Cancel";
        Object[] options = {okButton, cancelButton};

        optionPane = new JOptionPane(fields, 
                                     JOptionPane.PLAIN_MESSAGE,
                                     JOptionPane.OK_CANCEL_OPTION,
                                     null,
                                     options,
                                     options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);

        pack();
        setLocationRelativeTo(parent);
        
        // handles actions
        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();
			
                if (isVisible() 
                    && (e.getSource() == optionPane)
                    && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                      prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        // ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(okButton)) {
                        subject = subjectTextField.getText();
                        body = bodyTextArea.getText();
                        String recipientName = (String) recipientComboBox.getSelectedItem();
                        jid = (JID) recipients.get(recipientName);
                        if (jid == null)
                            jid = new JID(recipientName);
                        //if (nick.equals("") || server.equals("") || roomName.equals(""))
                        if (jid == null) {
                            JOptionPane.showMessageDialog(parent, 
                                          "Invalid recipient JID",
                                          "Error", 
                                          JOptionPane.ERROR_MESSAGE);
                            setVisible(false);
                            return;
                        }
                        setVisible(false);
                    }
                    else if (value.equals(cancelButton)) {
                        jid = null;
                        setVisible(false);
                    }
                }
            }
        });
    }
}