package nu.fw.jeti.plugins.buddyspacemaps.gui;

/*
 * BSNameDialog.java
 *
 * Project: BuddySpace
 * (C) Copyright Knowledge Media Institute 2003
 *
 *
 * Created on 3 November 2003, 11:40
 * 
 * E.S. de Boer
 * converted to jeti plugin
 */

import java.awt.*;
import javax.swing.*;
import java.beans.*; // Property change stuff
import java.util.*;

/**
 * Dialog for entering a text field.
 *
 * @author  Jiri Komzak, Knowledge Media Institute, Open University, United Kingdom
 */

public class BSNameDialog extends JDialog {
    private JOptionPane optionPane;
    public String name = null;
    
    /** Constructor */
    public BSNameDialog(Frame _parent, String title, String _defaultName) {
        super(_parent, title, true);
        
        final Frame parent = _parent;
        
        // fills jid hashtable and sorted jid combo box
        final JTextField nameTextField = new JTextField();
        if (_defaultName != null)
            nameTextField.setText(_defaultName);
        
        Object[] fields = {"Name: ", nameTextField};
                           //, "Jen tak: ", jenTak};
        
        final String okButton = "OK";
        final String cancelButton = "Cancel";
        Object[] options = {okButton, cancelButton};

        optionPane = new JOptionPane(fields, 
                                     JOptionPane.PLAIN_MESSAGE,
                                     JOptionPane.OK_CANCEL_OPTION,
                                     null,
                                     options,
                                     options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);

        pack();
        setLocationRelativeTo(parent);
        
        // handles actions
        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();
			
                if (isVisible() 
                    && (e.getSource() == optionPane)
                    && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                      prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        // ignore reset
                        return;
                    }

                    // Reset the JOptionPane's value.
                    // If you don't do this, then if the user
                    // presses the same button next time, no
                    // property change event will be fired.
                    optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(okButton)) {
                        name = nameTextField.getText();
                        setVisible(false);
                    }
                    else if (value.equals(cancelButton)) {
                        name = null;
                        setVisible(false);
                    }
                }
            }
        });
    }
}