/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2006 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail me at eric@jeti.tk or Jabber at jeti@jabber.org
 *
 *	Created on 15-jun-2006
 */
 
package nu.fw.jeti.plugins.colormessages;

import java.awt.Color;
import java.util.Iterator;
import java.util.List;

import javax.swing.text.JTextComponent;
import javax.swing.text.MutableAttributeSet;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;

import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.plugins.Plugins;
import nu.fw.jeti.plugins.Translator;
import nu.fw.jeti.plugins.Word;
import nu.fw.jeti.util.Preferences;

/**
 * @author E.S. de Boer
 *
 */
public class Plugin implements Plugins,Translator
{
	public final static String VERSION = "0.1";
	public final static String DESCRIPTION = "colormessages.Colors_the_text_you_send";
	public final static String MIN_JETI_VERSION = "0.7.6";
	public final static String NAME = "colormessages";
	public final static String ABOUT = "by E.S. de Boer";
	private int cycle=0;
	private Color[] colors;
	private final static int NO_COLORS=3;

	public static void init(Backend backend)
	{
		
	}
	
	public Plugin()
	{
		colors = new Color[3];
		for(int i=0;i<NO_COLORS;i++)
		{
			colors[i] = new Color(Preferences.getInteger("colormessages","color"+i,0));
		}
		
//		colors[0]= new Color(174,28,40);
//		colors[1]= new Color(255,165,0);
//		colors[2]= new Color(33,70,139);
	}
	
	public void unload(){}

	 public void init(JTextComponent text) {}
	
	public void translate(List wordList)
	{
		System.out.println(cycle);
		MutableAttributeSet set = new SimpleAttributeSet();
		StyleConstants.setForeground(set, colors[cycle]);
		for (Iterator iter = wordList.iterator(); iter.hasNext();)
		{
			Word word =(Word) iter.next();
			word.addAttributes(set);
		}
		cycle++;
		if(cycle==colors.length)cycle=0;
	}
}

/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
