/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2002 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/im me at jeti@jabberstudio.org
 *	Created on 19-jun-2006
 */
package nu.fw.jeti.plugins.colormessages;

import java.awt.*;
import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.plugins.PreferencesPanel;
import nu.fw.jeti.util.I18N;
import nu.fw.jeti.util.Preferences;

/**
 * @author E.S. de Boer
 */

public class PrefPanel extends PreferencesPanel
{
	private final static int NO_COLORS=3;
	private Color[] colors = new Color[NO_COLORS];
	private JButton[] buttons = new JButton[NO_COLORS];

	public PrefPanel(Backend backend)
	{
		for(int i=0;i<NO_COLORS;i++)
		{
			buttons[i] = new JButton(I18N.gettext("colormessages.Color_"+i));
			colors[i] = new Color(Preferences.getInteger("colormessages","color"+i,0));
			final int current =i;
			buttons[i].addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					Color c = JColorChooser.showDialog(PrefPanel.this.getTopLevelAncestor() ,I18N.gettext("alertwindow.Color"), colors[current]);
					if (c != null)
					{	
						buttons[current].setForeground(c);
						colors[current]=c;
					}
				}
			});
			buttons[i].setForeground(colors[i]);
			add(buttons[i]);
		}
	}

	public void savePreferences()
	{
		for(int i=0;i<NO_COLORS;i++)
		{
			Preferences.putInteger("colormessages","color"+i, colors[i].getRGB());
		}
	}

}
/*
 * Overrides for emacs Local variables: tab-width: 4 End:
 */
