/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2005 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/im me at jeti@jabber.org
 *  
 *  created 22-09-2007
 */
package nu.fw.jeti.plugins.compression;

import nu.fw.jeti.jabber.elements.Packet;

/**
 * @author E.S. de Boer
 *
 */
public class Compress extends Packet
{
	public static final String NAMESPACE = "http://jabber.org/protocol/compress";
	private String type = "compress";
	private String error;
	private String method;
	
	public Compress(String type,String method)
	{
		this.type = type;
		this.method = method;
	}
	
	public Compress(String type,String error,String method)
	{
		this.type = type;
		this.method = method;
		this.error = error;
	}
	
	public String getType()
	{
		return type;
	}

	public String getMethod()
	{
		return method;
	}
	
	public void appendToXML(StringBuffer xml)
	{
		xml.append("<" + type + " xmlns='" + NAMESPACE + "'>");
		appendElement(xml, "method", method);
		if(error!=null) appendElement(xml, error, true);
		xml.append(" </" + type + ">");
	}
}