/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2005 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/im me at jeti@jabber.org
 *  
 *  created 22-09-2007
 */
package nu.fw.jeti.plugins.compression;

import java.util.List;

import nu.fw.jeti.jabber.elements.Extension;

/**
 * @author E.S. de Boer
 *
 */
public class CompressionFeature extends Extension
{
	private List<String> methods;
	public static final String NAMESPACE = "http://jabber.org/features/compress";

	public CompressionFeature(List<String> methods)
	{
		this.methods = methods;
	}

	public List<String> getMethods()
	{
		return methods;
	}
	
	public void appendToXML(StringBuffer xml)
	{
		xml.append("<compression xmlns='" + NAMESPACE + "'>");
		if(methods!=null)
		{
			for (String method :  methods)
			{
				appendElement(xml, "method",method);
			}
		}
		xml.append(" </compression>");
	}
}
