/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2005 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/im me at jeti@jabber.org
 *  
 *  created 22-09-2007
 */
package nu.fw.jeti.plugins.compression;



import java.util.LinkedList;
import java.util.List;

import nu.fw.jeti.jabber.elements.Extension;
import nu.fw.jeti.jabber.handlers.ExtensionHandler;

import org.xml.sax.Attributes;

/**
 * @author E.S. de Boer
 *
 */
public class CompressionFeatureHandler extends ExtensionHandler
{
	private List<String> methods;

	public void startHandling(Attributes attr)
	{
		methods = new LinkedList<String>();
	}

	public void endElement(String name)
	{
		if (name.equals("method")) methods.add(getText());
		else nu.fw.jeti.util.Log.notParsedXML("compression" + name + getText());
		clearCurrentChars();
	}



	public Extension build()
	{
		return new CompressionFeature(methods); 
	}

	
}