package nu.fw.jeti.plugins.drawing.elements;

import java.util.List;

import nu.fw.jeti.jabber.JID;

/**
 * This class represents the message for deletion the list of shapes.
 * 
 * @author Elbieta Iwaszkiewicz (ei197866@students.mimuw.edu.pl)
 */
public class DeletionMessage extends PictureMessage {
	/**
	 * Tag used to send this message.
	 */
	public static final String TYPE_TAG = "delete";

	/**
	 * Constructs the message from the builder.
	 * 
	 * @param pmb
	 *            builder where all needed fields are set
	 */
	public DeletionMessage(PictureMessageBuilder pmb) {
		super(pmb);
	}

	/**
	 * Constructs the message and sets all the fields.
	 * 
	 * @param to
	 *            adresser of the message
	 * @param idList
	 *            list of shapes' id that will be deleted
	 * @param thread
	 *            thread of the chat
	 * @param time
	 *            time of the message
	 * @param author
	 * 			  action's author
	 * @param counter
	 *            counter of the message
	 */
	public DeletionMessage(JID to, List<Long> idList, String thread,
			String time, String author, int counter) {
		super(to, author, idList, thread, time, counter);
	}

	public void appendToXML(StringBuffer xml) {
		startAppendingToXML(xml, TYPE_TAG);
		endAppendingToXML(xml, TYPE_TAG);
	}
}
