package nu.fw.jeti.plugins.drawing.elements;

import java.util.List;

import nu.fw.jeti.jabber.JID;

/**
 * This class represents the message for displaying the shapes given by shapes'
 * id list.
 * 
 * @author Elbieta Iwaszkiewicz (ei197866@students.mimuw.edu.pl)
 */
public class DisplayMessage extends PictureMessage {
	/**
	 * Tag used to send this message.
	 */
	public static final String TYPE_TAG = "display";

	/**
	 * Constructs the message from the builder.
	 * 
	 * @param pmb
	 *            builder where all needed fields are set
	 */
	public DisplayMessage(PictureMessageBuilder pmb) {
		super(pmb);
	}

	/**
	 * Constructs the message and sets all the fields.
	 * 
	 * @param to
	 *            adresser of the message
	 * @param idList
	 *            list of shapes' id that will be displayed
	 * @param t
	 *            thread of the chat
	 * @param time
	 *            time of the message
	 * @param author
	 * 			  action's author
	 * @param c
	 *            counter of the message
	 */
	public DisplayMessage(JID to, List<Long> idList, String t, String time,
			String author, int c) {
		super(to, author, idList, t, time, c);
	}

	public void appendToXML(StringBuffer xml) {
		startAppendingToXML(xml, TYPE_TAG);
		endAppendingToXML(xml, TYPE_TAG);
	}

}
