/*
 * Created on 2006-02-28
 */
package nu.fw.jeti.plugins.drawing.shapes;

import java.awt.Color;

import nu.fw.jeti.jabber.JID;

/**
 * This class represents the abstract shape factory.
 * 
 * @author Elbieta Iwaszkiewicz (ei197866@students.mimuw.edu.pl)
 */
public abstract class ShapeFactory {

	/**
	 * Creates a Shape with given parameters.
	 * 
	 * @param author
	 *            shape's author
	 * @param color
	 *            shape's color
	 * @param coords
	 *            shape's coordinates
	 * @param height
	 *            shape's height
	 * @param id
	 *            shape's id
	 * @param isFilled
	 *            <tt>true</tt> if the shape is filled
	 * @return created Shape
	 */
	public abstract Shape createShape(long id, JID author, String coords,
			Color color, int height, boolean isFilled);
}
