package nu.fw.jeti.plugins.drawing.shapes.actions;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;

import nu.fw.jeti.jabber.JID;
import nu.fw.jeti.plugins.drawing.elements.BackgroundSettingMessage;
import nu.fw.jeti.plugins.drawing.elements.PictureMessage;
import nu.fw.jeti.plugins.drawing.shapes.PicturesContent;

/**
 * This class represents an Action that sets the background's color.
 * 
 * @author Elbieta Iwaszkiewicz (ei197866@students.mimuw.edu.pl)
 */
public class BackgroundColorSetting extends Action {
	Color oldColor;
	Color newColor;

	/**
	 * Creates new Action and sets all the fields.  It does not affect any
	 * shapes so it does not have a list of shapes' ids nor all shapes list.
	 * 
	 * @param oldC old color of the background
	 * @param newC new color of the background
	 * @param t Action's time
	 * @param author Action's author
	 * @param nr Action's counter
	 */
	public BackgroundColorSetting(Color oldC, Color newC, String t,
			String author, int nr) {
		super(null, null, t, author, nr);
		oldColor = oldC;
		newColor = newC;
	}

	public void execute(PicturesContent shapesBoard) {
		shapesBoard.setBackgroundColor(newColor);
	}

	public Action giveComplementaryAction(String time, int counter) {
		return new BackgroundColorSetting(newColor, oldColor, time, 
				actionsAuthor, counter);
	}

	public List<PictureMessage> getPictureMessageList(List<JID> receivers, String thread) {
		List<PictureMessage> list = new ArrayList<PictureMessage>();
		for (JID jid : receivers) {
			list.add(new BackgroundSettingMessage(jid, newColor, oldColor,
					thread, time, actionsAuthor, counter));
		}
		return list;
	}

}
