package nu.fw.jeti.plugins.drawing.shapes.actions;

import java.util.ArrayList;
import java.util.List;

import nu.fw.jeti.jabber.JID;
import nu.fw.jeti.plugins.drawing.elements.CurrentUsersMessage;
import nu.fw.jeti.plugins.drawing.elements.PictureMessage;
import nu.fw.jeti.plugins.drawing.shapes.PicturesContent;

/**
 * This class represents an Action that sends current chat users to all
 * the users.
 * 
 * @author Elbieta Iwaszkiewicz (ei197866@students.mimuw.edu.pl)
 */
public class CurrentUsersDelivery extends Action {
	List<JID> users;

	/**
	 * Creates new Action and sets all the fields.  It does not affect any
	 * shapes so it does not have a list of shapes' ids nor all shapes list.
	 * 
	 * @param usersList actual users in the chat
	 * @param t Action's time
	 * @param author Action's author
	 * @param nr Action's counter
	 */
	public CurrentUsersDelivery(List<JID> usersList,
			String t, String author, int nr) {
		super(null, null, t, author, nr);
		users = usersList;
	}

	/**
	 * Should not be called.
	 * @throws UnsupportedOperationException
	 */
	public void execute(PicturesContent shapesBoard) {
		throw new UnsupportedOperationException("CurrentUsersDelivery: This method should not be called.");
	}
	
	/**
	 * Should not be called.
	 * @throws UnsupportedOperationException
	 */
	public Action giveComplementaryAction(String t, int c) {
		throw new UnsupportedOperationException("CurrentUsersDelivery: This method should not be called.");
	}

	public List<PictureMessage> getPictureMessageList(List<JID> receivers,
			String thread) {
		List<PictureMessage> list = new ArrayList<PictureMessage>();
		for (JID jid : receivers) {
			list.add(new CurrentUsersMessage(jid, users, thread, time,
					actionsAuthor, counter));
		}
		return list;
	}

}
