package nu.fw.jeti.plugins.drawing.shapes.actions;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import nu.fw.jeti.jabber.JID;
import nu.fw.jeti.plugins.drawing.elements.DeletionMessage;
import nu.fw.jeti.plugins.drawing.elements.PictureMessage;
import nu.fw.jeti.plugins.drawing.shapes.PicturesContent;
import nu.fw.jeti.plugins.drawing.shapes.Shape;

/**
 * This class represents an Action that deletes the given shapes.
 * 
 * @author Elbieta Iwaszkiewicz (ei197866@students.mimuw.edu.pl)
 */
public class Deletion extends Action {

	/**
	 * Creates a new deletion action.
	 * 
	 * @param sIdList list of shapes' ids that are changed by this action
	 * @param allShapes map of all shapes that have ever been created
	 * @param t action's time
	 * @param author Action's author
	 * @param nr action's counter
	 */
	public Deletion(List<Long> sIdList, Map<Long, Shape> allShapes,
			String t, String author, int nr) {
		super(sIdList, allShapes, t, author, nr);
	}
	
	public void execute(PicturesContent shapesBoard) {
		for (long id : shapeIdList) {
			shapesBoard.deleteShape(allShapes.get(id));
		}
	}
	
	public Action giveComplementaryAction(String t, int c) {
		return new Display(shapeIdList, allShapes, t, actionsAuthor, c);
	}

	public List<PictureMessage> getPictureMessageList(List<JID> receivers,
			String thread) {
		List<PictureMessage> list = new ArrayList<PictureMessage>();
		for (JID jid : receivers) {
			list.add(new DeletionMessage(jid, shapeIdList, thread, time,
					actionsAuthor, counter));
		}
		return list;
	}
}
