package nu.fw.jeti.plugins.drawing.ui;

import java.awt.event.ActionEvent;
import java.util.Set;

import javax.swing.ImageIcon;
import javax.swing.JDialog;

import nu.fw.jeti.plugins.drawing.shapes.PictureChat;
import nu.fw.jeti.util.I18N;


public class AddUsersSelectAction extends UsersSelectAction {
	private PictureChat chat;
	private static final long serialVersionUID = 5397230411528858273L;

	public AddUsersSelectAction(
    		String text, 
    		ImageIcon icon,
    		String desc,
    		Integer mnemonic,
    		PictureChat c) {
        super(text, icon);
        chat = c;
        putValue(SHORT_DESCRIPTION, desc);
        putValue(MNEMONIC_KEY, mnemonic);
    }
    
    public void actionPerformed(ActionEvent e) {
		JDialog addUsersDialog = new AddUsersDialog(this, chat, chat.getBackend(),
				I18N.getText("drawing","Add_other_users_to_your_chat"), false);
		addUsersDialog.setVisible(true);
    }
    
    public void obsluzSelectedUsers(Set<UserRepresentation> selectedUsers) {
    	chat.addUsers(selectedUsers);
    }
}
