package nu.fw.jeti.plugins.drawing.ui;

import java.awt.event.ActionEvent;
import java.util.Set;

import javax.swing.ImageIcon;
import javax.swing.JDialog;

import nu.fw.jeti.plugins.drawing.shapes.PictureChat;
import nu.fw.jeti.util.I18N;

public class SelectUsersToHistoryAction extends UsersSelectAction {
	private static final long serialVersionUID = -5520840928672505032L;
	private PictureChat chat;
	private HistoryPanel historyPanel;

	public SelectUsersToHistoryAction(
    		String text, 
    		ImageIcon icon,
    		String desc,
    		Integer mnemonic,
    		PictureChat c,
    		HistoryPanel panel) {
        super(text, icon);
        chat = c;
        historyPanel = panel;
        putValue(SHORT_DESCRIPTION, desc);
        putValue(MNEMONIC_KEY, mnemonic);
    }
    
    public void actionPerformed(ActionEvent e) {
		JDialog addUsersDialog = new AddUsersDialog(this, chat, chat.getBackend(),
				I18N.getText("drawing","Select_whose_shapes_will_be_shown"), true);
		addUsersDialog.setVisible(true);
    }
    
    public void obsluzSelectedUsers(Set<UserRepresentation> selectedUsers) {
    	historyPanel.selectUsersToDisplay(selectedUsers);
    }
}
