package nu.fw.jeti.plugins.groupchat;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import nu.fw.jeti.events.DiscoveryListener;
import nu.fw.jeti.images.StatusIcons;
import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.jabber.JID;
import nu.fw.jeti.jabber.elements.DiscoItem;
import nu.fw.jeti.jabber.elements.DiscoveryInfo;
import nu.fw.jeti.jabber.elements.DiscoveryItem;
import nu.fw.jeti.util.I18N;
import nu.fw.jeti.util.Preferences;
import nu.fw.jeti.util.QueryServers;
import nu.fw.jeti.util.Utils;


/**
 * <p>Title: im</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2001</p>
 * <p>Company: </p>
 * @author E.S. de Boer
 * @version 1.0
 */

public class GroupchatSignin extends JFrame
{
    private JLabel jLabel1 = new JLabel();
    private JList listRooms = new JList(new DefaultListModel());
    //private Vector rooms = new Vector();
    private JTextField txtRoom = new JTextField();
    
    private JTextField txtNick = new JTextField();
    private JLabel jLabel2 = new JLabel();
     private JComboBox cmbChatRoomServer = new JComboBox();
    private JLabel jLabel3 = new JLabel();
    private JPanel jPanel4 = new JPanel();
    private JButton jButton1 = new JButton();
    private JButton btnOK = new JButton();
	private Backend backend;
    private RoomListener roomListener = new RoomListener();
    private ServerListener serverListener = new ServerListener();
   // private NicListener nicListener = new NicListener();
    

    public GroupchatSignin(Backend backend)
    {
		this.backend = backend;
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        
        JID server = new JID(backend.getMyJID().getDomain());
        backend.getItems(server, serverListener);
    }

    private void jbInit() throws Exception
    {
    	setTitle(I18N.gettext("groupchat.Choose_groupchat_room"));
    	setIconImage(StatusIcons.getImageIcon("jeti").getImage());
    	I18N.setTextAndMnemonic("groupchat.Room",jLabel1);
    	jLabel1.setLabelFor(listRooms);
        txtNick.setPreferredSize(new Dimension(200, 21));
        I18N.setTextAndMnemonic("groupchat.Nickname",jLabel2);
        jLabel2.setLabelFor(txtNick);
    
		getContentPane().setLayout(new BorderLayout());
        
        Action cancelAction = new AbstractAction(I18N.gettext("Cancel"))
		{
			public void actionPerformed(ActionEvent e)
			{
				dispose();
			}
		};
		Utils.addCancelButton(this, jButton1, cancelAction);
		
        btnOK.setText(I18N.gettext("OK"));
        getRootPane().setDefaultButton(btnOK);
        btnOK.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                btnOK_actionPerformed(e);
            }
        });
        
        JPanel jp = new JPanel(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();
		c.anchor = GridBagConstraints.LINE_START;
		c.fill = GridBagConstraints.HORIZONTAL;
		c.insets = new Insets(3, 5, 0, 3);
        
        if(!Preferences.getBoolean("groupchat", "hideServerChooser", false))
        {
	        JComboBox cmbServer = new JComboBox();
	        JLabel label = new JLabel();
	        I18N.setTextAndMnemonic("groupchat.Server",label);
			label.setLabelFor(cmbServer);
			        
	        cmbServer.addItem("");
	        cmbServer.addItem(backend.getMyJID().getDomain());
			for(Iterator i = QueryServers.getServers().iterator();i.hasNext();)
			{
				DiscoItem item = (DiscoItem)i.next();
				cmbServer.addItem(item.getJID().getDomain());
			}
			cmbServer.setSelectedItem(backend.getMyJID().getDomain());
					
			cmbServer.setPreferredSize(new Dimension(200, 21));
			cmbServer.addItemListener(new ItemListener() {
	            public void itemStateChanged(ItemEvent e) {
	                if (e.getStateChange() == ItemEvent.SELECTED) {
	                	String server = e.getItem().toString();
	                	if(JID.isValidServer(server))
	                	{
	                		cmbChatRoomServer.removeAllItems();
	                		((DefaultListModel)listRooms.getModel()).clear();
	                		backend.getItems(new JID(server), serverListener);
	                   	}
	                }
				}
			});
	        cmbServer.setEditable(true);
	        jp.add(label,c);
	        c.weightx=1;
	        c.gridwidth = GridBagConstraints.REMAINDER;
	        jp.add(cmbServer,c);
    	        
	        cmbChatRoomServer.setPreferredSize(new Dimension(200, 21));
	        cmbChatRoomServer.addItemListener(new ItemListener() {
	            public void itemStateChanged(ItemEvent e) {
	                if (e.getStateChange() == ItemEvent.SELECTED) {
	                	 Object o = cmbChatRoomServer.getSelectedItem();
	                	 if(o!=null)
	                	 {
		                	 if(o instanceof ChatServer)
		                	 {
		                	 	ChatServer cs = (ChatServer)o;
								setChatRoomServer(cs.getServer());
		                	 }
		                	 else if (!o.equals(""))setChatRoomServer(o.toString());
	                	 }
	                }
				}
			});
	        cmbChatRoomServer.setEditable(true);
	        I18N.setTextAndMnemonic("groupchat.Chat_Server",jLabel3);
	        jLabel3.setLabelFor(cmbChatRoomServer);
	        c.gridwidth = 1;
	        c.weightx=0;
	        jp.add(jLabel3, c);
	        c.weightx=1;
	        c.gridwidth = GridBagConstraints.REMAINDER;
	        jp.add(cmbChatRoomServer,c);
        }
        else
        {
        	String chatServer = Preferences.getString("groupchat", "defaultGroupchatServer","conference.jabber.org");
        	cmbChatRoomServer.addItem(chatServer);
        	cmbChatRoomServer.setSelectedItem(chatServer);
        	setChatRoomServer(chatServer);
        }
        
        if(!Preferences.getBoolean("groupchat", "hideNicknameChooser", false))
        {
	        c.gridwidth = 1;
	        c.weightx=0;
	        jp.add(jLabel2, c);
	        c.weightx=1;
	        c.gridwidth = GridBagConstraints.REMAINDER;
	        jp.add(txtNick, c);
        }
                
        listRooms.addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                if (!e.getValueIsAdjusting()) {
                    Object value = listRooms.getSelectedValue();
                	if(value!=null)txtRoom.setText(value.toString());
                }
			}
        });
           
        
        c.gridwidth = 1;
        c.weightx=0;
        jp.add(jLabel1, c);
        c.gridwidth = GridBagConstraints.REMAINDER;
        jp.add(txtRoom, c);
        c.gridwidth = 1;
        c.weightx=0;
        jp.add(new JLabel());        
        c.gridwidth = GridBagConstraints.REMAINDER;
        c.weightx=1;
        c.weighty=1;
        c.fill = GridBagConstraints.BOTH;
        jp.add(new JScrollPane(listRooms), c);
        this.getContentPane().add(jp,BorderLayout.CENTER);
        //getContentPane().add(new JScrollPane(cmbRoom), BorderLayout.CENTER);
        
        
        
       /*
        jPanel1.setLayout(new FlowLayout(FlowLayout.RIGHT));
        jPanel1.add(jLabel1, null);
        jPanel1.add(cmbRoom, null);
		getContentPane().add(jPanel1,BorderLayout.CENTER);
        */
        
        this.getContentPane().add(jPanel4, BorderLayout.SOUTH);
        jPanel4.add(btnOK, null);
        jPanel4.add(jButton1, null);
        pack();
        setLocationRelativeTo(null);
    }
    
    public void setChatRoomServer(String server)
    {
    	backend.getItems(new JID(server),roomListener, false);
    }
    
    
    void btnOK_actionPerformed(ActionEvent e)
    {
		String nick = txtNick.getText();
		if(nick.equals("")) {
            nick = backend.getMyJID().getUser();
        }

        String room;
        Room selectedRoom =(Room) listRooms.getSelectedValue();
        if (selectedRoom != null) {
            room = selectedRoom.getJID().getUser();
        } else {
        	room = txtRoom.getText();
            if (!JID.isValidUser(room)) {
                JOptionPane.showMessageDialog(
                    this, 
                    I18N.getTextWithAmp("Username_contains_illegal_chars_(see_english_translation)"),
                    I18N.gettext("groupchat.Illegal_group_name"),
                    JOptionPane.ERROR_MESSAGE);
                return;
            }
        }
        Object o = cmbChatRoomServer.getSelectedItem();
        if(o==null)return;
        String server;
	   	if(o instanceof ChatServer)
	   	{
	   	 	ChatServer cs = (ChatServer)o;
			server = cs.getServer();
	   	}
	   	else 
	   	{
	   		if(o.equals(""))return;
	   		server = o.toString();
	   	}
        
	   	JID jid = new JID(room, server, nick);
	   	
//		if(Start.applet){
//			GroupchatWindow gw = Plugin.createGroupChatWindow(jid);
//			Jeti applet = (Jeti) backend.getMainWindow();
//			applet.setContentPane(gw);
//			JMenu[] menu =  gw.getMenu();
//			setJMenuBar(new JMenuBar());
//			for(int i=0;i<menu.length;i++)
//			{
//				getJMenuBar().add(menu[i]);
//			}
//			applet.validate();
//		}
//		else {
			Plugin.startGroupchat(jid,backend);
//		}
		
        dispose();
    }

      
//    private void getRoomNic(String room)
//	{
//	// Do nothing since the params is not implemented XXX
//	//String server = cmbServer.getSelectedItem().toString();
//	//backend.getInfo(new JID(room, server),"x-roomuser-item",nicListener);
//	}

	private class RoomListener implements DiscoveryListener
	{
		public void discoveryInfoResult(JID jid, DiscoveryInfo browseResult)
		{}

		public void discoveryItemResult(JID jid, DiscoveryItem browseResult)
		{
			DefaultListModel model = new DefaultListModel();
			if (browseResult.hasItems())
			{
				ArrayList list = new ArrayList(); 
				for (Iterator i = browseResult.getItems(); i.hasNext();)
				{
					DiscoveryItem item = (DiscoveryItem) i.next();
					list.add(new Room(item.getName(),item.getJID()));
				}
				Collections.sort(list);
				for (Iterator i = list.iterator(); i.hasNext();)
				{
					model.addElement(i.next());
				}
			}
			listRooms.setModel(model);
		}
	}
	
	private static class Room implements Comparable
	{
		int members;
		String roomName;
		JID roomJID;
		
		private Room(String room, JID jid)
		{
			roomJID = jid;
			if(room==null) roomName = jid.getUser();
			else roomName = room;
			if(roomName.endsWith(")"));
			{
				int end =roomName.lastIndexOf("(");
				if(end!=-1)
				{
					try {
					String count = roomName.substring(end+1, roomName.length()-1);
					members = Integer.parseInt(count);
					}catch (NumberFormatException e) {}
				}
			}
		}
		
		public JID getJID()
		{
			return roomJID;
		}
		
		public String toString()
		{
			return roomName;
		}
		
		public int compareTo(Object o)
		{
			if (members<((Room)o).members) return 1;
			if (members>((Room)o).members) return -1;
			return roomName.compareTo(o.toString());
		}
	}
	
	

	private class ServerListener implements DiscoveryListener
	{
		public void discoveryInfoResult(JID jid, DiscoveryInfo item)
		{
//			not all servers support feature yet so use conference category
			if("conference".equals(item.getCategory()))cmbChatRoomServer.addItem(new ChatServer(jid,item.getName()));
			
//			if (item.hasFeatures())
//			{
//				for (Iterator i = item.getFeatures(); i.hasNext();)
//				{
//					String feature = (String) i.next();
//					System.out.println(feature);
//					if (feature.equals("http://jabber.org/protocol/muc"))
//					{
//						cmbChatRoomServer.addItem(new ChatServer(jid,item.getName()));
//					}
//				}
//			}
		}

		public void discoveryItemResult(JID jid, DiscoveryItem browseResult)
		{
			if (browseResult.hasItems())
			{
				for (Iterator i = browseResult.getItems(); i.hasNext();)
				{
					DiscoveryItem item = (DiscoveryItem) i.next();
					backend.getInfo(item.getJID(), this);
				}
			}
		}
	}

//	private static class NicListener implements DiscoveryListener
//	{
//		public void discoveryInfoResult(JID jid, DiscoveryInfo item)
//		{
//		// Handle nic identity packet
//		}
//
//		public void discoveryItemResult(JID jid, DiscoveryItem browseResult)
//		{}
//	}
	
	static class ChatServer
	{
		private String name;
		private String server;
		
		public ChatServer(JID jid, String name)
		{
			server = jid.getDomain();
			if(name==null || name.equals("")) this.name = server;
			else this.name = name;
		}
		
		public String getServer()
		{
			return server;
		}
		
		public String toString()
		{
			return name;
		}
	}
}

/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
