package nu.fw.jeti.plugins.groupchat.elements;

import java.awt.event.WindowEvent;

import javax.swing.JFrame;

import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.jabber.JID;
import nu.fw.jeti.jabber.XDataCallback;
import nu.fw.jeti.jabber.XDataPanel;
import nu.fw.jeti.jabber.elements.InfoQuery;
import nu.fw.jeti.jabber.elements.XData;
import nu.fw.jeti.util.I18N;
import nu.fw.jeti.util.Popups;

/**
 * @author Martin Forssen
 */
public class IQMUCOwnerConfigure extends IQMUC implements IQMUCInterface
{
    public IQMUCOwnerConfigure(Backend backend, JID roomJID) {
    	super("owner", backend, roomJID,null);
        send("get", this);
    }

    public IQMUCOwnerConfigure(Backend backend, JID roomJID, XData xdata) {
        super("owner", backend, roomJID, xdata);
        send("set", this);
    }
	
    public void execute(InfoQuery iq,Backend backend, IQMUC muc)
    {
        if (iq.getType().equals("result")) {
            if(muc.getXData() != null) {
            	XDataFrame x = new XDataFrame(backend,muc.getXData(),iq.getFrom(),iq.getID());
				x.setVisible(true);
            }
        } else if (iq.getType().equals("error")) {
            Popups.errorPopup(iq.getErrorDescription(), "Register Error");
        }
    }

    public void timeout() {};

    static class XDataFrame extends JFrame implements XDataCallback
    {
        private Backend backend;
        private JID jid;
		 
        public XDataFrame(Backend backend,XData xData,JID jid, String id)
        {
            this.backend = backend;
            this.jid =jid;
            setIconImage(nu.fw.jeti.images.StatusIcons.getImageIcon("jeti").getImage());
            if(xData.getTitle() !=null) setTitle(xData.getTitle());
            else setTitle(I18N.gettext("groupchat.Configure_Room"));
            setContentPane(new XDataPanel(xData,this));
            this.addWindowListener(new java.awt.event.WindowAdapter()
            {
                public void windowClosing(WindowEvent e)
                {
                    cancelForm();
                }
            });
            //pack();
            setSize(550,700);
        }
		
        public void sendForm(XData xdata) {
            new IQMUCOwnerConfigure(backend, jid, xdata);
            this.dispose(); 		
        }

        public void cancelForm() {
            new IQMUCOwnerConfigure(backend, jid, new XData("cancel"));
            this.dispose(); 
        }
    }
}	

/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
