// Created on 7-okt-2003
package nu.fw.jeti.plugins.groupchat.handlers;

import nu.fw.jeti.jabber.JID;
import nu.fw.jeti.jabber.elements.Extension;
import nu.fw.jeti.jabber.handlers.ExtensionHandler;
import nu.fw.jeti.plugins.groupchat.elements.XMUCUser;
import nu.fw.jeti.plugins.groupchat.elements.XMUCUserInvite;
import nu.fw.jeti.util.Log;

import org.xml.sax.Attributes;

/**
 * @author E.S. de Boer
 *
 */
public class XMUCUserHandler extends ExtensionHandler
{
	private JID jid;
	private String nick;
	private String affiliation;
	private String role;
	private int statuscode;
    private String reason;
    private boolean decline;
    private boolean invite;
	
	public void startHandling(Attributes attr)
	{//no attrs
		jid=null;
		nick=null;
		affiliation = null;
		role = null;
		statuscode=0;
        reason = null;
	}

	public void startElement(String name,Attributes attr)
	{
		if(name.equals("invite"))
		{
			invite = true;
			checkJID(name, attr.getValue("from"));
		}
		else if (name.equals("decline"))
		{
			decline = true;
			invite = true;
		}
		if(name.equals("item"))
		{
			checkJID(name, attr.getValue("jid"));
			affiliation = attr.getValue("affiliation");
			role = attr.getValue("role");
			nick = attr.getValue("nick");
		}
		else if(name.equals("status"))
		{
			try {
				statuscode = Integer.parseInt(attr.getValue("code"));
			}catch (NumberFormatException e)
			{
				Log.notParsedXML("XMUC#User " + name + getText());
			}
		}
		else Log.notParsedXML("XMUC#User " + name + getText());
	}

	private void checkJID(String name, String jidString)
	{
		try
		{
			jid = JID.checkedJIDFromString(jidString);
		}
		catch (InstantiationException e)
		{
			Log.notParsedXML("XMUC#User " + name + getText());
		}
	}

	public void endElement(String name)
	{
        if(name.equals("reason"))
		{
            reason = getText();
		}
		clearCurrentChars();
	}

	public Extension build()
	{
		if (invite) return new XMUCUserInvite(jid,reason,decline);
        return new XMUCUser(affiliation,role,nick,jid,statuscode,reason);
	}
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
