/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2004 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail me at eric@jeti.tk
 */

// Created on 17-jun-2005
package nu.fw.jeti.plugins.ichatavatars;

import nu.fw.jeti.jabber.elements.Extension;
import nu.fw.jeti.jabber.elements.XExtension;

/**
 * @author E.S. de Boer
 *
 */
public class AvatarUpdate extends Extension implements XExtension
{
	private String hash;
	private String nick;
	
	public AvatarUpdate()
	{
	}
	
	public AvatarUpdate(String hash)
	{
		this.hash=hash;
	}
	
	public AvatarUpdate(String hash,String nick)
	{
		this.hash=hash;
		this.nick = nick;
	}
	
	public String getHash() {
		return hash;
	}

	public String getNick() {
		return nick;
	}

	public void appendToXML(StringBuffer xml)
	{
		xml.append("<x xmlns='vcard-temp:x:update'>");
		appendElement(xml, "photo", hash);
		appendElement(xml, "nickname", nick);
		xml.append("</x>");
	}
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
