/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2004 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail me at jeti@jabberstudio.org
 */

// Created on 17-jun-2005
package nu.fw.jeti.plugins.ichatavatars;

import nu.fw.jeti.jabber.elements.Extension;
import nu.fw.jeti.jabber.handlers.ExtensionHandler;

import org.xml.sax.Attributes;

/**
 * @author E.S. de Boer
 */
public class AvatarUpdateHandler extends ExtensionHandler
{
	private String photo;
	private String nick;

	public void startHandling(Attributes attr)
	{
		nick =null;
		photo=null;
	}
		
	public void endElement(String name)
	{
		if(name.equals("photo")) photo = getText();
		else if(name.equals("nickname")) nick = getText();
		clearCurrentChars();
	}

	public Extension build()
	{
		return new AvatarUpdate(photo,nick);
	}

}
/*
 * Overrides for emacs Local variables: tab-width: 4 End:
 */
