/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2001 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/IM me at jeti@jabber.org
 *  
 *  Created on 15-jul-2005
 */

package nu.fw.jeti.plugins.metaltheme;

import java.awt.Color;

import javax.swing.plaf.ColorUIResource;
import javax.swing.plaf.metal.DefaultMetalTheme;

import nu.fw.jeti.util.Preferences;

/**
 * @author E.S. de Boer
 *
 */
class MyTheme extends DefaultMetalTheme
{
    public String getName() { return "MyTheme"; }
    private ColorUIResource[] colors = new ColorUIResource[8];
       
    public MyTheme()
    {
    	 colors[0] =  new ColorUIResource(0x0, 0x33, 0x99);
    	 colors[1] = new ColorUIResource(0xD0, 0xDD, 0xFF);
    	 colors[2] = new ColorUIResource(0x0, 0x99, 0xFF); 
    	 colors[3] = new ColorUIResource(0x6F, 0x6F, 0x6F);
    	 colors[4] = new ColorUIResource(0x9F, 0x9F, 0x9F);
    	 colors[5] = new ColorUIResource(0x1f, 0x7f, 0xDC);
    	 colors[6] = new ColorUIResource(Color.WHITE);
    	 colors[7] = new ColorUIResource(Color.BLACK);
    }
    public void load()
    {
	 	for(int i=0;i<colors.length;i++)
		{
			int rgb = Preferences.getInteger("metaltheme","color"+i,colors[i].getRGB());
			colors[i] =  new ColorUIResource(rgb);
		}
    }
    
    public ColorUIResource[] getColors() {return colors;}
    
    protected ColorUIResource getPrimary1() { return colors[0]; }  
    protected ColorUIResource getPrimary2() { return colors[1]; } 
    protected ColorUIResource getPrimary3() { return colors[2]; } 
    
    protected ColorUIResource getSecondary1() { return colors[3]; }
    protected ColorUIResource getSecondary2() { return colors[4]; }
    protected ColorUIResource getSecondary3() { return colors[5]; }
    
    public ColorUIResource getWhite() { return colors[6];}
    public ColorUIResource getBlack() { return colors[7];}
}
