/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2004 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail me at eric@jeti.tk or Jabber at jeti@jabber.org
 *
 *	Created on 9-okt-2004
 */
 
package nu.fw.jeti.plugins.openpgp;

import nu.fw.jeti.events.PresenceListener;
import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.plugins.Plugins;
import nu.fw.jeti.plugins.PluginsInfo;


//TODO add security questions

/**
 * @author E.S. de Boer
 *
 */
public class Plugin implements Plugins
{
	public final static String VERSION = "0.1";
	public final static String DESCRIPTION = "openpgp.Encryption";
	public final static String MIN_JETI_VERSION = "0.6";
	public final static String NAME = "openpgp";
	public final static String ABOUT = "by E.S. de Boer";
	private static Plugin plugin;
	//private Backend backend;
	private Encrypter encrypter;
	
					
	public Plugin(Backend backend)
	{
		PluginsInfo.loadLibrary("cryptix-pki-api");
		PluginsInfo.loadLibrary("cryptix-jce-api");
		PluginsInfo.loadLibrary("cryptix-openpgp-provider");
		PluginsInfo.loadLibrary("cryptix-message-api");
		PluginsInfo.loadLibrary("cryptix-jce-provider");
		
        
       encrypter = new Encrypter();
		
		backend.addListener(PresenceListener.class,encrypter);
		backend.addExtensionHandler("jabber:x:signed",new XSignedHandler());
		backend.addExtensionHandler("jabber:x:encrypted",new XEncryptedHandler());
		
	}
	
	public static void init(Backend backend)
    {
    	plugin = new Plugin(backend);
    }

	public void unload()
	{

	}
	
	public static Object getInstance()
	{
		return Encrypter.getInstance();
	}

	public static void unload(Backend backend)
	{
		backend.removeListener(PresenceListener.class, plugin.encrypter);
		backend.removeExtensionHandler("jabber:x:signed");
		backend.removeExtensionHandler("jabber:x:encrypted");
		plugin.unload();
		plugin = null;
	}
	
//	public boolean verify(KeyBundle pubkey) throws MessageException
//    {
//        return verify((PublicKey)pubkey.getPublicKeys().next());
//    }
		
	
}

/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
