/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2007 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 */

// Created on 21-jan-2007
package nu.fw.jeti.plugins.pubsub;

import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.jabber.elements.Extension;
import nu.fw.jeti.jabber.elements.IQExtension;
import nu.fw.jeti.jabber.elements.InfoQuery;
import nu.fw.jeti.jabber.elements.XData;

/**
 * @author E.S. de Boer
 *
 */
public class PubsubCreate extends Extension implements IQExtension
{
	private String node;
	private XData form;
	
	public PubsubCreate(String node,XData form)
	{
		this.form = form;
		this.node = node;
	}
	
	public PubsubCreate(String node)
	{
		this.node = node;
	}
		
	public XData getXDataForm()
	{
		return form;
	}
	
	public String getNode()
	{
		return node;
	}
	
	public void execute(InfoQuery iq, Backend backend)
	{}
		
	public void appendToXML(StringBuffer xml)
	{
		xml.append("<pubsub xmlns='http://jabber.org/protocol/pubsub'>");
		xml.append("<create");
		appendAttribute(xml,"node",node);
		xml.append("/>");
		if(form!=null)
		{
			xml.append("<configure>");
			form.appendToXML(xml);
			xml.append("</configure>");
		}
		xml.append("</pubsub>");
	}
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
