/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2001 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/IM me at jeti@jabber.org
 *  
 *  Created on 18-feb-2007
 */

package nu.fw.jeti.plugins.pubsub;

import nu.fw.jeti.backend.XExecutableExtension;
import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.jabber.elements.Extension;
import nu.fw.jeti.jabber.elements.Message;
import nu.fw.jeti.jabber.elements.Packet;

public class PubsubEvent extends Extension implements XExecutableExtension
{
	private PubSubExtension extension;
	private String node;
	
	public PubsubEvent(PubSubExtension extension) {
		this.extension = extension;
	}
	
	public void execute(Packet packet,Backend backend) {
		if(extension!=null)extension.execute((Message)packet,backend);
	}
	
	public void appendToXML(StringBuffer xml)
	{
		xml.append("<event xmlns='http://jabber.org/protocol/pubsub#event'>");
		xml.append("<items");
		appendAttribute(xml, "node", node);
		xml.append(">");
		xml.append("<item>");
		((Extension)extension).appendToXML(xml);
		xml.append("</item>");
		xml.append("</publish>");
		xml.append("</pubsub>");
	}
	
}
