/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2007 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 */

// Created on 21-jan-2007
package nu.fw.jeti.plugins.pubsub;

import nu.fw.jeti.jabber.elements.Extension;
import nu.fw.jeti.jabber.elements.XData;
import nu.fw.jeti.jabber.elements.XMPPErrorTag;
import nu.fw.jeti.jabber.handlers.ExtensionHandler;
import nu.fw.jeti.util.Log;

import org.xml.sax.Attributes;

/**
 * @author E.S. de Boer
 *
 */
public class PubsubHandler extends ExtensionHandler
{
	private XData form;
	private String node;
	
	
	public void startHandling(Attributes attr)
	{
		form=null;
		
	}
	
	 public void startElement(String name, Attributes attr) 
	 {
	        if (name.equals("create")) {
	        	node = attr.getValue("node");
	        }
	        else if (name.equals("configure")) {
	        	
	        }
	        else Log.notParsedXML("Pubsub element not known " + name);
	 }
	
	public void addExtension(Extension extension)
	{
		if(extension instanceof XData)
		{
			form = (XData)extension;
		}
	
		else Log.notParsedXML("Si Extension not known " + extension);
	}

	public void endElement(String name)
	{
		if("configure".equals(name))
		{
			
		}
		getText();
		clearCurrentChars();
	}

	public Extension build()
	{
		if(!getName().equals("si"))return new XMPPErrorTag(getName(),"http://jabber.org/protocol/si");
		return new Pubsub(null,null);
	}
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
