/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2001 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/IM me at jeti@jabber.org
 */

// Created on 27-feb-2003

package nu.fw.jeti.plugins.search;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import nu.fw.jeti.events.RegisterListener;
import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.jabber.elements.Extension;
import nu.fw.jeti.jabber.elements.IQExtension;
import nu.fw.jeti.jabber.elements.InfoQuery;
import nu.fw.jeti.jabber.elements.XData;
import nu.fw.jeti.util.I18N;
import nu.fw.jeti.util.Popups;


/**
 * @author E.S. de Boer
 * @version 1.0
 */

public class IQSearch extends Extension implements IQExtension
{
	private Map fields;
	private List list;
	private XData xdata;

	public IQSearch(){}

	public IQSearch(XData xdata){this.xdata = xdata;}
	
	public IQSearch(Map fields,XData xdata)
	{
		
		this.fields =fields;
		this.xdata = xdata;
	}

	public IQSearch(Map fields)
	{
		//System.out.println(fields);
		this.fields =fields;
	}
	
	public IQSearch(List list)
	{
		this.list = list;
	}

	public Map getFields(){return fields;}
	
	public List getList(){return list;}
	
	public XData getXData(){return xdata;}
	
	public void execute(InfoQuery iq,Backend backend)
	{
		if (iq.getType().equals("result"))
		{
			new SearchWindow(backend,this,iq.getFrom(),iq.getID()).setVisible(true);
		}
		else if (iq.getType().equals("error"))
		{
			Popups.errorPopup(iq.getErrorDescription(), I18N.gettext("main.error.Register_Error"));
		}
	}


	public void appendToXML(StringBuffer xml)
	{
		xml.append("<query xmlns=\"jabber:iq:search\"");
		if(fields == null && xdata == null)
		{ //short cut
			xml.append("/>");
			return;
		}
		xml.append('>');
		appendElement(xml,fields);
		//add list
		if(xdata != null) xdata.appendToXML(xml); 
		xml.append("</query>");
	}
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
