package nu.fw.jeti.plugins.search;

import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.Map;

import nu.fw.jeti.jabber.elements.Extension;
import nu.fw.jeti.jabber.elements.IQRegister;
import nu.fw.jeti.jabber.elements.XData;
import nu.fw.jeti.jabber.handlers.ExtensionHandler;

import org.xml.sax.Attributes;

/**
 * @author E.S. de Boer
 * @version 1.0
 */

public class IQSearchHandler extends ExtensionHandler
{
	private Map fields;
	private XData xdata;//xdata
	private LinkedList list;

	public void startHandling(Attributes attr)
	{
		reset();
	}

	private void reset()
	{
		fields =null;
		xdata = null;
		list = null;
	}
	
	public void startElement(String name,Attributes attr)
	{
		if(name.equals("item"))
		{
			if(list == null)list = new LinkedList();
			fields = new LinkedHashMap(14);
			fields.put("JID",attr.getValue("jid"));
		}
	}
	

	public void endElement(String name)
	{//parse everything
		if(name.equals("item"))list.add(fields);
		else 
		{
			if(fields == null)fields = new LinkedHashMap(14);
			fields.put(name,getText());
		}
		//else util.Log.notParsedXML("iq:auth " + name + getText());
		clearCurrentChars();
	}
	
	public void addExtension(Extension extension)
	{
		if(extension instanceof XData) xdata = (XData) extension;
	}

	public Extension build()
	{
		Extension e = null;
		if(xdata != null)
		{
			e = new IQSearch(fields,xdata);
		}
		else if (list !=null)e = new IQSearch(list);
		else e = new IQSearch(fields);
		reset();
		return e;
	}
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
