/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2001 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/IM me at jeti@jabber.org
 */

// Created on 27-feb-2003
package nu.fw.jeti.plugins.search;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JMenuItem;

import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.plugins.Plugins;
import nu.fw.jeti.util.I18N;


/**
 * @author E.S. de Boer
 *
 */
public class Plugin extends JFrame implements Plugins
{
	public final static String VERSION = "0.2";
	public final static String DESCRIPTION = "search.Search_a_user_on_a_Jabber_Server";
	public final static String MIN_JETI_VERSION = "0.5.1";
	public final static String NAME = "search";
	public final static String ABOUT = "by E.S. de Boer";
	private static JMenuItem menuItem;
				
	public static void init(final Backend backend)
	{
		menuItem = new JMenuItem();
		I18N.setTextAndMnemonic("search.Search_user", menuItem, true);
		menuItem.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				//String jud = JOptionPane.showInputDialog(null,"Please enter the user direcotry server");
				//if(jud==null)return;
				//backend.send(new InfoQuery(new JID(jud),"get",new IQSearch()));
				new JUDChooser(backend);
			}
		});
		backend.getMain().addToMenu(menuItem);
		backend.addExtensionHandler("jabber:iq:search",new IQSearchHandler());
	}
	
	public static void unload(Backend backend)
	{
		backend.getMain().removeFromMenu(menuItem);
		backend.removeExtensionHandler("jabber:iq:search");
	}
	
	public void unload() {}
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
