/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2001 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/IM me at jeti@jabber.org
 */

// Created on 27-feb-2003

package nu.fw.jeti.plugins.search;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.swing.*;

import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.jabber.JID;
import nu.fw.jeti.jabber.XDataCallback;
import nu.fw.jeti.jabber.XDataPanel;
import nu.fw.jeti.jabber.elements.InfoQuery;
import nu.fw.jeti.jabber.elements.XData;
import nu.fw.jeti.jabber.elements.XDataField;
import nu.fw.jeti.ui.AddContact;
import nu.fw.jeti.util.I18N;
import nu.fw.jeti.util.Utils;

public class SearchWindow extends JFrame implements XDataCallback 
{
    
    private JPanel jPanel2 = new JPanel();
    private JButton btnOK = new JButton();
    private JButton btnCancel = new JButton();
	private JPanel pnlInstructions = new JPanel();
    private JTextArea txtInstructions = new JTextArea();
    private JLabel jLabel1 = new JLabel();
	private String key;
	private Map map;
	private Backend backend;
	private JID from;
	private String id;
	public static final int STRUT_SIZE = 5;
	private int current =0;
	private List results;
	
	public SearchWindow(Backend backend,IQSearch register,JID jid,String id)
	{
		from = jid;
		this.id = id;
		this.backend = backend;
		XData xData =register.getXData();
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		if(xData !=null)
		{
			createXDataForm(xData);
		}
		else
		{
			oldSearch(register);
		}
		pack();
		setLocationRelativeTo(null);
		setVisible(true);  
	}

	private void createXDataForm(XData xData)
	{
		setIconImage(nu.fw.jeti.images.StatusIcons.getImageIcon("jeti").getImage());
		if(xData.getTitle() !=null) setTitle(xData.getTitle());
		else setTitle(I18N.gettext("search.User_Search"));
		if(xData.getType().equals("form"))
		{
			setContentPane(new XDataPanel(xData,this));
		}
		else if (xData.hasItems() || xData.hasItems())
		{
			final XDataPanel xDataPanel = new XDataPanel(xData,this); 
			JPanel panel = new JPanel();
			JButton button = new JButton();
			I18N.setTextAndMnemonic("search.Add_to_Roster",button);
			button.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					JID jid=null;
					String nick=null;
					for(Iterator i = xDataPanel.getCurrentField();i.hasNext();)
					{
						XDataField data = (XDataField)i.next();
						if("jid".equals(data.getVar()))
						{
							jid = JID.jidFromString(data.getValue());
						}
						else if("nick".equals(data.getVar()))nick  = data.getValue();
					}
					if(jid!=null)new AddContact(jid,nick,null,backend).setVisible(true);
			
				}
			});
			panel.add(button);
			button = new JButton();
			I18N.setTextAndMnemonic("search.Chat",button);
			button.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					for(Iterator i = xDataPanel.getCurrentField();i.hasNext();)
					{
						XDataField data = (XDataField)i.next();
						if("jid".equals(data.getVar()))
						{
							JID jid = JID.jidFromString(data.getValue());
							backend.getMain().startChat(jid);
						}
					}
				}
			});
			panel.add(button);	
			getContentPane().add(xDataPanel,BorderLayout.CENTER);
			getContentPane().add(panel,BorderLayout.SOUTH);
		}
		else 
		{
			getRootPane().setDefaultButton(btnOK);
			I18N.setTextAndMnemonic("search.Search_Again",btnOK);
			btnOK.addActionListener(new java.awt.event.ActionListener()
	        {
	            public void actionPerformed(ActionEvent e)
	            {
	            	dispose();
	            	new JUDChooser(backend);
	            }
	        });
			getContentPane().add(new JLabel(I18N.gettext("search.No_User_Found,_try_with_different_search_terms")), BorderLayout.CENTER);
			getContentPane().add(btnOK, BorderLayout.SOUTH);
		}
		this.addWindowListener(new java.awt.event.WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				cancelForm();
			}
		});
	}
	
	private void oldSearch(IQSearch register)
	{
		setIconImage(nu.fw.jeti.images.StatusIcons.getImageIcon("jeti").getImage());
		setTitle(I18N.gettext("search.User_Search"));
		List list = register.getList();
		if(list!=null)createMulti(list);
		else if(register.getFields()!=null)
		{
			Map forms = register.getFields();
			map = new LinkedHashMap(15);
			key =(String) forms.remove("key");
			jPanel2.setLayout(new BoxLayout(jPanel2,BoxLayout.Y_AXIS));
			if(forms.containsKey("instructions"))
			{
				String instructions = (String)forms.remove("instructions");
				txtInstructions.setText(instructions);
				txtInstructions.setEnabled(false);
				jLabel1.setText(I18N.gettext("main.register.Instructions"));
				jLabel1.setPreferredSize(new Dimension(80, 17));
				pnlInstructions.setLayout(new BorderLayout());
				pnlInstructions.add(jLabel1, BorderLayout.WEST  );
				pnlInstructions.add(txtInstructions, BorderLayout.CENTER);
				/*
				java.awt.FontMetrics font = getFontMetrics((Font)UIManager.get("TextArea.font"));
				int naamLengte = (font.stringWidth(message));
				if(naamLengte > 400)
				{//message is to long enable autowrap
					font.getHeight();
					txtInstructions.setPreferredSize(new Dimension(400    ))
					txtInstructions.setLineWrap(true);
					return;
				}
				*/
				jPanel2.add(Box.createVerticalStrut(STRUT_SIZE));
				jPanel2.add(pnlInstructions);
			}
			getContentPane().add(jPanel2, BorderLayout.CENTER);
			jbInit(false);
			makeForm(forms,jPanel2);
		}
		else 
		{
			getContentPane().add(new JLabel(I18N.gettext("search.No_User_Found,_try_with_different_search_terms")), BorderLayout.CENTER);
			jbInit(true);
		}
	}

	private void makeForm(Map forms,JPanel pnlForm)
	{
		for (Iterator i=forms.entrySet().iterator(); i.hasNext(); ) {
			Map.Entry e = (Map.Entry) i.next();
		//	System.out.println(e.getKey() + ": " + e.getValue());

			JTextField text;
			//if(((String)e.getKey()).equals("password")) text = new JPasswordField();
			text = new JTextField();

			//text.setPreferredSize(new Dimension(200, 21));
			text.setText((String)e.getValue());

			JPanel panel = new JPanel();
			panel.setLayout(new BorderLayout());
			if(map!=null)map.put(e.getKey(),text);
			JLabel label = new JLabel((String)e.getKey());
			label.setPreferredSize(new Dimension(80, 17));
			panel.add(label, BorderLayout.WEST);
			panel.add(text,BorderLayout.CENTER);
			pnlForm.add(Box.createVerticalStrut(STRUT_SIZE));
			pnlForm.add(panel);
		}
	}

	private void createMulti(final List list)
	{
		results = list;
		jbInit(true);
		if(list.size()>1)
		{
			JPanel panel = new JPanel();
			final JButton btnNext = new JButton();
			final JButton btnPrevious = new JButton();
			I18N.setTextAndMnemonic("search.Previous", btnPrevious);
			panel.add(btnPrevious,BorderLayout.EAST);
			final JLabel title = new JLabel("1/" + list.size());
			panel.add(title,BorderLayout.CENTER);
			btnPrevious.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					if(current!=0)current--;
					if(current==0)btnPrevious.setEnabled(false);
					if(current==list.size()-2)btnNext.setEnabled(true);
					title.setText(current + 1 + "/" + list.size());
					gotoPostion(list);
				}
			});
			I18N.setTextAndMnemonic("search.Next", btnNext);
			btnNext.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					if(current<list.size()-1)current++;
					if(current==list.size()-1)btnNext.setEnabled(false);
					if(current==1)btnPrevious.setEnabled(true);
					title.setText(current + 1 + "/" + list.size());
					gotoPostion(list);
				}
			});
			panel.add(btnNext,BorderLayout.EAST);
			getContentPane().add(panel, BorderLayout.NORTH);
		}
		jPanel2.setLayout(new BoxLayout(jPanel2,BoxLayout.Y_AXIS));
		getContentPane().add(jPanel2, BorderLayout.CENTER);
		makeForm((Map)list.get(0), jPanel2);
	}
	
	private void gotoPostion(List list)
	{
		Map form =(Map) list.get(current);
		final JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel,BoxLayout.Y_AXIS));
		makeForm(form, panel);
		SwingUtilities.invokeLater(new Runnable()
		{
			public void run()
			{
				getContentPane().remove(jPanel2);
				jPanel2 = panel;
				getContentPane().add(jPanel2, BorderLayout.CENTER);
				validate();
			}
		});
	}

    private void jbInit(final boolean isResult)
    {
    	JPanel jPanel1 = new JPanel();
    	JPanel jPanel2 = new JPanel();
    	JPanel jPanel3 = new JPanel(new BorderLayout());
		getRootPane().setDefaultButton(btnOK);
		if(isResult)
		{
			I18N.setTextAndMnemonic("search.Search_Again",btnOK);
		}
		if(results !=null)
		{	
			JButton button = new JButton();
			I18N.setTextAndMnemonic("search.Add_to_Roster",button);
			button.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					Map map = (Map)results.get(current);
					System.out.println("dfdf" + map.get("JID"));
					JID jid = JID.jidFromString((String)map.get("JID"));
					if(jid==null)return;
					new AddContact(jid,(String)map.get("nick"),null,backend).setVisible(true);			
				}
			});
			jPanel2.add(button);
			button = new JButton();
			I18N.setTextAndMnemonic("search.Chat",button);
			button.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					Map map = (Map)results.get(current);
					System.out.println("dfdf" + map.get("JID"));
					JID jid = JID.jidFromString((String)map.get("JID"));
					if(jid==null)return;
					backend.getMain().startChat(jid);
				}
			});
			jPanel2.add(button);
			jPanel3.add(jPanel2,BorderLayout.NORTH);
		}
		else I18N.setTextAndMnemonic("OK",btnOK);
        btnOK.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
            	if(isResult)
            	{
            		dispose();
            		new JUDChooser(backend);
            	}
            	else btnOK_actionPerformed(e);
            }
        });
        Action cancelAction = new AbstractAction(I18N.gettext("Cancel"))
		{
			public void actionPerformed(ActionEvent e)
			{
				if(isResult)dispose();
				else btnCancel_actionPerformed(e);
			}
		};
		Utils.addCancelButton(this, btnCancel, cancelAction);
        
        //txtInstructions.setPreferredSize(new Dimension(200, 17));
		jPanel1.add(btnOK, null);
        jPanel1.add(btnCancel, null);
        jPanel3.add(jPanel1,BorderLayout.SOUTH);
        this.getContentPane().add(jPanel3,  BorderLayout.SOUTH);
    }

    void btnCancel_actionPerformed(ActionEvent e)
    {
		this.dispose();
    }

    void btnOK_actionPerformed(ActionEvent e)
    {
			setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
			btnOK.setEnabled(false);
			btnCancel.setEnabled(false);
			LinkedHashMap tmap = new LinkedHashMap(16);
			for (Iterator i=map.entrySet().iterator(); i.hasNext(); )
			{
			    Map.Entry entry = (Map.Entry) i.next();
				String value = ((javax.swing.JTextField)entry.getValue()).getText().trim();
				if(value .equals("")) continue;
			    tmap.put(entry.getKey(),value);
			}
			tmap.put("key",key);
			backend.send(new InfoQuery(from,"set",new IQSearch(tmap)));
			this.dispose();
	}
	
	public void sendForm(XData xdata)
	{
		backend.send(new InfoQuery(from,"set",id,new IQSearch(xdata)));
		this.dispose(); 		
	}
	
	public void cancelForm()
	{
		//backend.send(new InfoQuery(from,"set",id,new IQSearch(new XData("cancel"))));
		this.dispose(); 
	}
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
