/**
 * @(#) Language.java
 */

package nu.fw.jeti.plugins.translate;
import java.io.*;
import java.util.*;

public class Language implements Serializable{
    private String shortName;
    private String fullName;
    private static final Hashtable langs = new Hashtable();
    public static final Language ZH = new Language("ZH", "Chinese-simp");
    public static final Language ZT = new Language("ZT", "Chinese-trad");
    public static final Language EN = new Language("EN", "English");
    public static final Language NL = new Language("NL", "Dutch");
    public static final Language FR = new Language("FR", "French");
    public static final Language DE = new Language("DE", "German");
    public static final Language EL = new Language("EL", "Greek");
    public static final Language IT = new Language("IT", "Italian");
    public static final Language JA = new Language("JA", "Japanese");
    public static final Language KO = new Language("KO", "Korean");
    public static final Language PT = new Language("PT", "Portuguese");
    public static final Language RU = new Language("RU", "Russian");
    public static final Language ES = new Language("ES", "Spanish");
    
    public static Language forShortName(String shortName){
        return (Language)langs.get(shortName);
    }
    public static Language forFullName(String fullName){
        Enumeration ls = langs.elements();
        for(;ls.hasMoreElements();){
            Language lang = (Language)ls.nextElement();
            if(lang.getFullName().equals(fullName))
                return lang;
        }
        return null;
    }
    protected Language( String shortName, String fullName) {
        this.shortName = shortName;
        this.fullName = fullName;
        langs.put(shortName, this);
    }
    public String toString( ) {
        return fullName;
    }
    
    /**
     * Getter for property fullName.
     * @return Value of property fullName.
     */
    public java.lang.String getFullName() {
        return fullName;
    }
    
    /**
     * Setter for property fullName.
     * @param fullName New value of property fullName.
     */
    public void setFullName(java.lang.String fullName) {
        this.fullName = fullName;
    }
    
    /**
     * Getter for property shortName.
     * @return Value of property shortName.
     */
    public java.lang.String getShortName() {
        return shortName;
    }
    
    public static Enumeration getAllLanguages(){
        return langs.elements();
    }
    
    /**
     * Setter for property shortName.
     * @param shortName New value of property shortName.
     */
    public void setShortName(java.lang.String shortName) {
        this.shortName = shortName;
    }

    /*
    private void writeObject(java.io.ObjectOutputStream out)throws IOException{
        out.writeUTF(shortName);
    }
    private void readObject(java.io.ObjectInputStream in)throws IOException, ClassNotFoundException{
        shortName = in.readUTF();
    }*/
    private Object readResolve() throws ObjectStreamException{
        return Language.forShortName(shortName);
    }
    
}
