/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2003 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/IM me at jeti@jabber.org
 *
 *	Created on 28-mei-2006
 */

package nu.fw.jeti.plugins.translate;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.text.MessageFormat;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.*;
import javax.swing.border.EmptyBorder;
import javax.swing.text.BadLocationException;
import javax.swing.text.JTextComponent;

import nu.fw.jeti.events.MessageListener;
import nu.fw.jeti.events.PresenceListener;
import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.jabber.JID;
import nu.fw.jeti.jabber.JIDStatus;
import nu.fw.jeti.jabber.elements.Message;
import nu.fw.jeti.jabber.elements.Presence;
import nu.fw.jeti.plugins.*;
import nu.fw.jeti.ui.ChatSplitPane;
import nu.fw.jeti.util.I18N;
import nu.fw.jeti.util.Preferences;


/**
 * @author E.S. de Boer
 * @version 1.0
 */

public class Plugin implements Plugins, Translate
{
	public final static String VERSION = "0.1";
	public final static String DESCRIPTION = "translate.Translates_text_using_babelfish";
	public final static String MIN_JETI_VERSION = "0.7.6";
	public final static String NAME = "translate";
	public final static String ABOUT = "by E.S. de Boer, uses JTrans and babelfish";
				
	public Plugin() 
	{
		
	}
	
	public void init(final ChatSplitPane chatPane, final JTextPane txtInput)
	{
		JMenu subMenu = new JMenu(I18N.gettext("translate.Translate"));
		Direction[] directions = BabelFishTranslator.getSupportedDirections();
		for (int i = 0; i < directions.length; i++)
		{
			JMenuItem item = new JMenuItem(directions[i].toString());
			item.setActionCommand(Integer.toString(i));
			item.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					System.out.println(((JMenuItem)e.getSource()).getText());
					int d = Integer.parseInt(e.getActionCommand());
					
					try
					{
						Direction direction = BabelFishTranslator.getSupportedDirections()[d];
						String text = chatPane.getSelectedText();
						String toTranslate = URLEncoder.encode(text, "UTF-8");
						String translated = new BabelFishTranslator().translate(direction, toTranslate, false, 100);
						txtInput.getDocument().insertString(txtInput.getDocument().getLength(), translated, null);
					} catch (UnsupportedEncodingException e1)
					{
						// TODO Auto-generated catch block
						e1.printStackTrace();
					} catch (BadLocationException e2)
					{
						// TODO Auto-generated catch block
						e2.printStackTrace();
					}
				}
			});
			subMenu.add(item);
		}
		chatPane.addToSelectedTextPopupMenu(subMenu);
	}
	
	
	public void translate(String text)
	{
		new TranslateWindow(text);
	}
	
	
    public static void init(Backend backend)
    {


	}
	
   
	public void unload()
	{
	
	}
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
