/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2001 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/IM me at jeti@jabber.org
 *  
 *  Created on 28-mei-2006
 */

package nu.fw.jeti.plugins.translate;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JTextField;

public class TranslateWindow extends JFrame
{

	public TranslateWindow(final String text)
	{
		setTitle("Translating " +text);
		final BabelFishTranslator babel = new BabelFishTranslator();
		final JComboBox box = new JComboBox(babel.getSupportedDirections());
		box.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				Object item =box.getSelectedItem();
				if(item!=null)
				{
					try
					{
						String toTranslate = URLEncoder.encode(text, "UTF-8");
						String translated = babel.translate((Direction)item, toTranslate, false, 100);
						showTranslated(translated);
					} catch (UnsupportedEncodingException e1)
					{
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				}
			}
		
		});
		
		getContentPane().add(box);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);	
		pack();
		setVisible(true);
	}
	
	public void showTranslated(String translated)
	{
		getContentPane().removeAll();
		JTextField textField = new JTextField(translated);
		textField.setEditable(false);
		getContentPane().add(textField);
		pack();
	}
	
}
