/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2007 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 */

// Created on 11-feb-2007

package nu.fw.jeti.plugins.useractivity;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JMenu;
import javax.swing.JMenuItem;

import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.plugins.Plugins;
import nu.fw.jeti.plugins.PluginsInfo;
import nu.fw.jeti.util.I18N;

/**
 * @author E.S. de Boer
 *
 */
public class Plugin implements Plugins
{
	public final static String VERSION = "0.1";
	public final static String DESCRIPTION = "useractivity.Activity_info";
	public final static String MIN_JETI_VERSION = "0.7.6";
	public final static String NAME = "pubsub";
	public final static String ABOUT = "by E.S. de Boer";
	private static JMenu menu;
	
	public static void init(Backend backend)
	{
		menu = new JMenu(I18N.gettext("useractivity.Activity"));
		addMenu("doing_chores",new String[]{"buying_groceries","cleaning","cooking",
				"doing_maintenance","doing_the_dishes","doing_the_laundry","gardening",
				"running_an_errand","walking_the_dog"});
		addMenu("drinking",new String[]{"having_a_beer","having_coffee","having_tea"});
		addMenu("eating",new String[]{"having_breakfast","having_lunch","having_dinner",
        	"having_a_snack"});
		addMenu("exercising",new String[]{"cycling","hiking","jogging","playing_sports",
				"running","skiing","swimming","working_out"});
		addMenu("grooming", new String[]{"at_the_spa","brushing_teeth","getting_a_haircut",
				"shaving","taking_a_bath","taking_a_shower"});
		
		JMenu generalMenu = new JMenu(I18N.gettext("having_appointment"));
		generalMenu.addMouseListener(new MouseAdapter()
		{
			public void mouseClicked(MouseEvent e)
			{
				new UserActivity("having_appointment");
			}
		});
		menu.add(generalMenu);
		addMenu("inactive",new String[]{"day_off","hanging_out","on_vacation",
				"scheduled_holiday","sleeping"});
		addMenu("relaxing",new String[]{"gaming","going_out","partying","reading",
		        "rehearsing","shopping","socializing","sunbathing","watching_tv","watching_a_movie"});
		addMenu("talking", new String[]{"in_real_life","on_the_phone"});
		addMenu("traveling", new String[]{"commuting","cycling","driving","in_a_car",
		        "on_a_bus","on_a_plane","on_a_train","on_a_trip","walking"});
		addMenu("working", new String[]{"coding","in_a_meeting","studying","writing"});
		backend.getMain().addToMenu(menu);
		backend.addExtensionHandler("http://jabber.org/protocol/activity",new UserActivityHandler());
	}
	
	
	private static void addMenu(final String general, String[] specifics ){
		JMenu generalMenu = new JMenu(I18N.gettext("useractivity."+ general));
		generalMenu.addMouseListener(new MouseAdapter()
		{
			public void mouseClicked(MouseEvent e)
			{
				nu.fw.jeti.plugins.pubsub.Plugin.getPluginInstance().publish(
                        "http://jabber.org/protocol/activity",new UserActivity(general,null)); 
				menu.setPopupMenuVisible(false);
			}
		});
		for(int i = 0;i<specifics.length;i++){
			final String specific = specifics[i];
			JMenuItem menuItem = new JMenuItem(I18N.gettext("useractivity."+specific));
			menuItem.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					nu.fw.jeti.plugins.pubsub.Plugin.getPluginInstance().publish(
	                        "http://jabber.org/protocol/activity",new UserActivity(general,specific));
				}
			});
			generalMenu.add(menuItem);
		}
		menu.add(generalMenu);
	}
		
	public void unload() {}
	
	public static void unload(Backend backend)
	{
		backend.removeExtensionHandler("http://jabber.org/protocol/activity");
		backend.getMain().removeFromMenu(menu);
	}

}

/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
