/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2007 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 */

// Created on 11-feb-2007
package nu.fw.jeti.plugins.useractivity;

import nu.fw.jeti.jabber.Backend;
import nu.fw.jeti.jabber.elements.*;
import nu.fw.jeti.plugins.pubsub.PubSubExtension;

/**
 * @author E.S. de Boer
 *
 */
public class UserActivity extends Extension implements PubSubExtension
{
	private String text;
	private String general;
	private String specific;

	public UserActivity(String general) {
		this.general = general;
	}
	
	public UserActivity(String general, String specific) {
		this.general = general;
		this.specific = specific;
	}
	
	public UserActivity(String general, String specific,String text) {
		this.text = text;
		this.general = general;
		this.specific = specific;
	}
		
	public String getGeneral() {
		return general;
	}

	public String getSpecific() {
		return specific;
	}

	public String getText() {
		return text;
	}
	
	public void execute(Message message,Backend backend)
	{
		System.out.println(message.getFrom() + "has activity " + general);
	}

	public void appendToXML(StringBuffer xml)
	{
		xml.append("<activity xmlns='http://jabber.org/protocol/activity'>");
		xml.append("<"+ general + ">");	
		if(specific!=null)xml.append("<"+specific+"/>");
		xml.append("</"+ general + ">");
		appendElement(xml, "text",text);
		xml.append("</activity>");
	}
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
