/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2005 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/im me at jeti@jabber.org
 *  
 *  created 13-10-2005
 */

package nu.fw.jeti.plugins.xmpp;

import java.util.Map;

import nu.fw.jeti.jabber.elements.Extension;
import nu.fw.jeti.jabber.elements.Packet;

public class Features extends Packet
{
	private Map<Class<? extends Extension>,Extension> features;
	
	protected Features(Map<Class<? extends Extension>,Extension> features)
	{
		this.features = features;
	}
	
	public boolean hasFeature(Class<? extends Extension> feature)
	{
		return features.containsKey(feature);
	}
	
	public Extension getFeature(Class<? extends Extension> feature)
	{
		return features.get(feature);
	}
	
    public void appendToXML(StringBuffer xml)
    {
        xml.append("<stream:features>");
        for(Extension extension : features.values()) extension.appendToXML(xml);
		xml.append("</stream:features>");
    }
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
