/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2005 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/im me at jeti@jabber.org
 *  
 *  created 15-10-2005
 */
package nu.fw.jeti.plugins.xmpp.sasl;

import java.util.List;

import nu.fw.jeti.jabber.elements.Extension;

/**
 * @author E.S. de Boer
 *
 */
public class SaslMechanisms extends Extension
{
	private List<String> mechanisms;
	public static final String NAMESPACE = "urn:ietf:params:xml:ns:xmpp-tls";

	public SaslMechanisms(List<String> mechanisms)
	{
		this.mechanisms = mechanisms;
	}

	public List<String> getMechanisms()
	{
		return mechanisms;
	}
	
	public void appendToXML(StringBuffer xml)
	{
		xml.append("<mechanisms xmlns='" + NAMESPACE + "'>");
		if(mechanisms!=null)
		{
			for (String mechanism :  mechanisms)
			{
				appendElement(xml, "mechanism",mechanism);
			}
		}
		xml.append(" </mechanisms>");
	}
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
