/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2005 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/im me at jeti@jabber.org
 *  
 *  created 13-10-2005
 */

package nu.fw.jeti.plugins.xmpp.tls;

import nu.fw.jeti.jabber.elements.Packet;

public class StartTlsPacket extends Packet
{
	private boolean failure;
	private boolean succeded;
	private String error;
	

	public StartTlsPacket(){}
	
	protected StartTlsPacket(boolean failure,String error)
	{
		this.failure = failure;
		this.error = error;
		if(!failure)succeded=true;
	}
	
	public boolean hasFailed()
	{
		return failure;
	}
	
	public String getError()
	{
		return error;
	}
		
    public void appendToXML(StringBuffer xml)
    {
    	if(succeded)xml.append("<proceed xmlns='urn:ietf:params:xml:ns:xmpp-tls'/>");
    	else if(failure)xml.append("<failure xmlns='urn:ietf:params:xml:ns:xmpp-tls'/>");
        else xml.append("<starttls xmlns='urn:ietf:params:xml:ns:xmpp-tls'/>");
		//startTls.appendToXML(xml);
		//xml.append("</stream:features>");
    }
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
