/* 
 *	Jeti, a Java Jabber client, Copyright (C) 2005 E.S. de Boer  
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	For questions, comments etc, 
 *	use the website at http://jeti.jabberstudio.org
 *  or mail/im me at jeti@jabber.org
 *  
 *  created 13-10-2005
 */

package nu.fw.jeti.plugins.xmpp.tls;
import nu.fw.jeti.jabber.elements.Extension;
import nu.fw.jeti.jabber.elements.Packet;
import nu.fw.jeti.jabber.handlers.PacketHandler;

import org.xml.sax.Attributes;


public class StartTlsPacketHandler extends PacketHandler
{
	private boolean failure;
	private String error;
	
	public StartTlsPacketHandler(boolean failure)
	{
		this.failure = failure;
	}
	
	public void startHandling(Attributes attr)
	{
		error = null;
	}

	public void endElement(String name)
	{
		error = name;
		clearCurrentChars();
	}
	
	public void addExtension(Extension extension){}

	
	public Packet build()
	{
		return new StartTlsPacket(failure,error);
	}
}
/*
 * Overrides for emacs
 * Local variables:
 * tab-width: 4
 * End:
 */
